/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.40 from the
 * contents of SSH2.xs. Do not edit this file, edit SSH2.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "SSH2.xs"
/*
 * SSH2.xs - C functions for Net::SSH2
 *
 * Authors: D. Robins, Rafael Kitover, Salvador Fandiño
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#define NEED_sv_2pv_flags
#define NEED_newRV_noinc
#define NEED_sv_2pv_nolen
#include "ppport.h"

#if PERL_REVISION == 5 && (PERL_VERSION < 8 || (PERL_VERSION == 8 && PERL_SUBVERSION < 4 ))

#  ifdef SvPVbyte_force
#    undef SvPVbyte_force
#  endif
#  define SvPVbyte_force(sv,lp) SvPV_force(sv,lp)

#  ifdef SvPVbyte_nolen
#    undef SvPVbyte_nolen
#  endif
#  define SvPVbyte_nolen SvPV_nolen

#endif


#include <libssh2.h>
#include <libssh2_sftp.h>
#include <libssh2_publickey.h>

#define LIBSSH2_HOSTKEY_POLICY_STRICT   1
#define LIBSSH2_HOSTKEY_POLICY_ASK      2
#define LIBSSH2_HOSTKEY_POLICY_TOFU     3
#define LIBSSH2_HOSTKEY_POLICY_ADVISORY 4

#define LIBSSH2_EXTENDED_DATA_STDERR    SSH_EXTENDED_DATA_STDERR
#define LIBSSH2_CHANNEL_FLUSH_STDERR    SSH_EXTENDED_DATA_STDERR

#include "const-c.inc"

#if defined(USE_ITHREADS) && (defined(I_PTHREAD) || defined(WIN32))

#ifdef USE_GCRYPT
#define HAVE_GCRYPT
#include <gcrypt.h>
#else /* OpenSSL */
#define HAVE_OPENSSL
#include <openssl/crypto.h>
#endif

#else
/* is #warning portable across C compilers? */
/* NO, an error with -pedantic */
/* #warning "Building a non-threadsafe Net::SSH2" */
#endif

#ifndef MULTIPLICITY
/* for debugging output */
#define my_perl ((void *)0)
#endif

/* constants */

#ifndef LIBSSH2_ERROR_NONE
#define LIBSSH2_ERROR_NONE 0
#endif  /* LIBSSH2_ERROR_NONE */

/* LIBSSH2_ERROR_* values; from 0 continuing negative */
static const char *const xs_libssh2_error[] = {
    "NONE",
    "SOCKET_NONE",
    "BANNER_NONE",
    "BANNER_SEND",
    "INVALID_MAC",
    "KEX_FAILURE",
    "ALLOC",
    "SOCKET_SEND",
    "KEY_EXCHANGE_FAILURE",
    "TIMEOUT",
    "HOSTKEY_INIT",
    "HOSTKEY_SIGN",
    "DECRYPT",
    "SOCKET_DISCONNECT",
    "PROTO",
    "PASSWORD_EXPIRED",
    "FILE",
    "METHOD_NONE",
    "AUTHENTICATION_FAILED",
    "PUBLICKEY_UNVERIFIED",
    "CHANNEL_OUTOFORDER",
    "CHANNEL_FAILURE",
    "CHANNEL_REQUEST_DENIED",
    "CHANNEL_UNKNOWN",
    "CHANNEL_WINDOW_EXCEEDED",
    "CHANNEL_PACKET_EXCEEDED",
    "CHANNEL_CLOSED",
    "CHANNEL_EOF_SENT",
    "SCP_PROTOCOL",
    "ZLIB",
    "SOCKET_TIMEOUT",
    "SFTP_PROTOCOL",
    "REQUEST_DENIED",
    "METHOD_NOT_SUPPORTED",
    "INVAL",
    "INVALID_POLL_TYPE",
    "PUBLICKEY_PROTOCOL",
    "EAGAIN",
    "ERROR_BUFFER_TOO_SMALL",
    "BAD_USE",
    "ERROR_COMPRESS",
    "OUT_OF_BOUNDARY",
    "AGENT_PROTOCOL",
    "SOCKET_RECV",
    "ENCRYPT",
    "BAD_SOCKET",
    "KNOWN_HOSTS",
    "CHANNEL_WINDOW_FULL",
    "KEYFILE_AUTH_FAILED",
};

/* SSH_FX_* values; from 0 continuing positive */
static const char *const sftp_error[] = {
    "OK",
    "EOF",
    "NO_SUCH_FILE",
    "PERMISSION_DENIED",
    "FAILURE",
    "BAD_MESSAGE",
    "NO_CONNECTION",
    "CONNECTION_LOST",
    "OP_UNSUPPORTED",
    "INVALID_HANDLE",
    "NO_SUCH_PATH",
    "FILE_ALREADY_EXISTS",
    "WRITE_PROTECT",
    "NO_MEDIA",
    "NO_SPACE_ON_FILESYSTEM",
    "QUOTA_EXCEEDED",
    "UNKNOWN_PRINCIPLE",
    "LOCK_CONFLICT",
    "DIR_NOT_EMPTY",
    "NOT_A_DIRECTORY",
    "INVALID_FILENAME",
    "LINK_LOOP"
};

/* private internal functions */

#define countof(x) (sizeof(x)/sizeof(*x))

#define XLATATTR(name, field, flag) \
    else if (strEQ(key, name)) { \
        attrs.field = SvUV(ST(i + 1)); \
        attrs.flags |= LIBSSH2_SFTP_ATTR_##flag; \
    }

typedef int SSH2_RC; /* for converting true/false to 1/undef */
typedef int SSH2_BYTES; /* for functions returning a byte count or a negative number to signal an error */
typedef libssh2_int64_t SSH2_BYTES64; /* the same for unsigned 64bit numbers */
typedef libssh2_uint64_t SSH2_BYTESU64; /* the same for unsigned 64bit numbers */
typedef int SSH2_ERROR; /* for returning SSH2 error numbers */
typedef int SSH2_NERROR; /* for converting SSH2 error code to boolean just indicating success or failure */
typedef int SSH2_BOOL; /* for yes/no responses */

typedef IV SSH2_METHOD;       /* LIBSSH2_METHOD_ constants */
typedef IV SSH2_FLAG;         /* LIBSSH2_FLAG_ constants */
typedef IV SSH2_CALLBACK;     /* LIBSSH2_CALLBACK_ constants */
typedef IV SSH2_HOSTKEY_HASH; /* LIBSSH2_HOSTKEY_HASH_ constants */
typedef IV SSH2_CHANNEL_EXTENDED_DATA; /* SSH2_CHANNEL_EXTENDED_DATA_ constants */
typedef IV SSH2_STREAM_ID;    /* stream_id or LIBSSH2_CHANNEL_FLUSH macros */
typedef char * SSH2_CHARP;         /* string that can not be NULL */
typedef char * SSH2_CHARP_OR_NULL; /* string that can be NULL */

/* Net::SSH2 object */
typedef struct SSH2 {
    LIBSSH2_SESSION* session;
    SV* sv_ss;  /* NB: not set until callback() called */
    SV* socket;
    SV* hostname;
    int port;
    SV* sv_tmp;
    SV* rgsv_cb[LIBSSH2_CALLBACK_X11 + 1];
} SSH2;

/* Net::SSH2::Channel object */
typedef struct SSH2_CHANNEL {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_CHANNEL* channel;
} SSH2_CHANNEL;

/* Net::SSH2::SFTP object */
typedef struct SSH2_SFTP {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_SFTP* sftp;
} SSH2_SFTP;

/* Net::SSH2::Listener object */
typedef struct SSH2_LISTENER {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_LISTENER* listener;
} SSH2_LISTENER;

/* Net::SSH2::File object */
typedef struct SSH2_FILE {
    SSH2_SFTP* sf;
    SV* sv_sf;
    LIBSSH2_SFTP_HANDLE* handle;
} SSH2_FILE;

/* Net::SSH2::Dir object */
typedef struct SSH2_DIR {
    SSH2_SFTP* sf;
    SV* sv_sf;
    LIBSSH2_SFTP_HANDLE* handle;
} SSH2_DIR;

/* Net::SSH2::PublicKey object */
typedef struct SSH2_PUBLICKEY {
    SSH2* ss;
    SV* sv_ss;
    LIBSSH2_PUBLICKEY* pkey;
} SSH2_PUBLICKEY;

#if LIBSSH2_VERSION_NUM >= 0x010200

/* Net::SSH2::KnownHosts object */
typedef struct SSH2_KNOWNHOSTS {
    SSH2 *ss;
    SV *sv_ss;
    LIBSSH2_KNOWNHOSTS* knownhosts;
} SSH2_KNOWNHOSTS;

#endif

static int net_ss_debug_out = 0;
static unsigned long gensym_count = 0;

/* debug output */
static void debug(const char* format, ...) {
    if (net_ss_debug_out) {
        va_list va;
        va_start(va, format);
        vwarn(format, &va);
        va_end(va);
    }
}

/* libssh2 allocator thunks */
LIBSSH2_ALLOC_FUNC(local_alloc) {
    void *buf;
    New(0, buf, count, char);
    return buf;
}
LIBSSH2_REALLOC_FUNC(local_realloc) {
    return Renew(ptr, count, char);
}
LIBSSH2_FREE_FUNC(local_free) {
    Safefree(ptr);
}

#define SV2TYPE(sv, type) ((type)((sizeof(IV) < sizeof(type)) ? SvNV(sv) : SvIV(sv)))
#define SV2UTYPE(sv, type) ((type)((sizeof(IV) < sizeof(type)) ? SvNV(sv) : SvUV(sv)))

static void
wrap_tied_into(SV *to, const char *pkg, void *object) {
    GV* gv = (GV*)newSVrv(to, pkg);
    IO* io = (IO*)newSV(0);
    SV* name_sv = sv_2mortal(newSVpvf("_GEN_%ld", (long)gensym_count++));
    STRLEN name_len;
    const char *name = SvPVbyte(name_sv, name_len);
        
    SvUPGRADE((SV*)gv, SVt_PVGV);
    gv_init(gv, gv_stashpv(pkg, GV_ADD), name, name_len, 0);
    SvUPGRADE((SV*)io, SVt_PVIO);

    GvSV(gv) = newSViv(PTR2IV(object));
    GvIOp(gv) = io;
#if PERL_VERSION > 6
    sv_magic((SV*)io, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
#else
    sv_magic((SV*)gv, newRV((SV*)gv), PERL_MAGIC_tiedscalar, Nullch, 0);
#endif
}

static IV
unwrap(SV *sv, const char *pkg, const char *method) {
    if (SvROK(sv) && sv_isa(sv, pkg)) {
        SV *inner = SvRV(sv);
        if (SvIOK(inner))
            return SvIVX(inner);
    }
    croak("%s::%s: invalid object %s", pkg, method, SvPV_nolen(sv));
}

static IV
unwrap_tied(SV *sv, const char *pkg, const char *method) {
    if (SvROK(sv) && sv_isa(sv, pkg)) {
        SV *gv = SvRV(sv);
        if (SvTYPE(gv) == SVt_PVGV) {
            SV *inner = GvSV((GV*)gv);
            if (inner && SvIOK(inner))
                return SvIVX(inner);
        }
    }
    croak("%s::%s: invalid object %s", pkg, method, SvPV_nolen(sv));
}

/* push a hash of values onto the return stack, for '%hash = func()' */
static int push_hv(SV** sp, HV* hv) {
    I32 keys = hv_iterinit(hv);
    const char* pv_key;
    I32 len_key;
    SV* value;

    EXTEND(SP, keys * 2);
    while ((value = hv_iternextsv(hv, (char**)&pv_key, &len_key))) {
        PUSHs(sv_2mortal(newSVpvn(pv_key, len_key)));
        PUSHs(sv_2mortal(SvREFCNT_inc(value)));
    }
    SvREFCNT_dec(hv);
    return keys * 2;
}

static SV *
sv_upper(SV *sv) {
    STRLEN len, i;
    char *pv = SvPVbyte(sv, len);
    for (i = 0; i < len; i++) {
        if (isLOWER(pv[i])) {
            sv = sv_2mortal(newSVpvn(pv, len));
            pv = SvPVX(sv);
            for (; i < len; i++)
                pv[i] = toUPPER(pv[i]);
            break;
        }
    }
    return sv;
}

static IV
sv2iv_constant_or_croak(const char *name, SV *sv) {
    if (!SvOK(sv) || SvIOK(sv) || looks_like_number(sv))
        return SvIV(sv);
    else {
        STRLEN len;
        char *pv;
        int type, i;
        IV value;
        sv = sv_upper(sv);
        pv = SvPVbyte(sv, len);
        type = constant(aTHX_ pv, len, &value);
        if (type == PERL_constant_NOTFOUND) {
            sv = sv_2mortal(newSVpvf("LIBSSH2_%s_%s", name, pv));
            pv = SvPVbyte(sv, len);
            type = constant(aTHX_ SvPV_nolen(sv), len, &value);
        }
        if (type == PERL_constant_ISIV)
            return value;

        croak("Invalid constant of type LIBSSH2_%s (%s)", name, pv);
    }
}

/* create a hash from an SFTP attributes structure */
static HV*
hv_from_attrs(LIBSSH2_SFTP_ATTRIBUTES* attrs) {
    HV* hv = newHV();
    debug("hv_from_attrs: attrs->flags = %d\n", attrs->flags);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_SIZE)
        hv_store(hv, "size", 4, newSVuv(attrs->filesize), 0/*hash*/);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_UIDGID) {
        hv_store(hv, "uid", 3, newSVuv(attrs->uid), 0/*hash*/);
        hv_store(hv, "gid", 3, newSVuv(attrs->gid), 0/*hash*/);
    }
    if (attrs->flags & LIBSSH2_SFTP_ATTR_PERMISSIONS)
        hv_store(hv, "mode", 4, newSVuv(attrs->permissions), 0/*hash*/);
    if (attrs->flags & LIBSSH2_SFTP_ATTR_ACMODTIME) {
        hv_store(hv, "atime", 5, newSVuv(attrs->atime), 0/*hash*/);
        hv_store(hv, "mtime", 5, newSVuv(attrs->mtime), 0/*hash*/);
    }
    return hv;
}

/* return attributes from function, as flat hash or hashref */
#define XSRETURN_STAT_ATTRS(name) XSRETURN(return_stat_attrs(sp, &attrs, name))
    
static int return_stat_attrs(SV** sp, LIBSSH2_SFTP_ATTRIBUTES* attrs,
 SV* name) {
    HV* hv_attrs = hv_from_attrs(attrs);
    if (name)
        hv_store(hv_attrs, "name", 4, name, 0/*hash*/);

    switch (GIMME_V) {
    case G_SCALAR:
        PUSHs(sv_2mortal(newRV_noinc((SV*)hv_attrs)));
        return 1;
    case G_ARRAY:
        return push_hv(sp, hv_attrs);
    default:
        SvREFCNT_dec(hv_attrs);
    }
    return 0;
}

/* general wrapper */
#define NEW_ITEM(type, field, create, parent) do { \
    Newz(0/*id*/, RETVAL, 1, type); \
    if (RETVAL) { \
        RETVAL->parent = parent; \
        RETVAL->sv_##parent = SvREFCNT_inc(SvRV(ST(0))); \
        RETVAL->field = create; \
        debug(#create " -> 0x%p\n", RETVAL->field); \
    } \
    if (!RETVAL || !RETVAL->field) { \
        if (RETVAL) \
            SvREFCNT_dec(RETVAL->sv_##parent); \
        Safefree(RETVAL); \
        XSRETURN_EMPTY; \
    } \
} while(0)

/* wrap a libSSH2 channel */
#define NEW_CHANNEL(create) NEW_ITEM(SSH2_CHANNEL, channel, create, ss)

/* wrap a libSSH2 listener */
#define NEW_LISTENER(create) NEW_ITEM(SSH2_LISTENER, listener, create, ss)

/* wrap a libSSH2 SFTP connection */
#define NEW_SFTP(create) NEW_ITEM(SSH2_SFTP, sftp, create, ss)

/* wrap a libSSH2 SFTP file */
#define NEW_FILE(create) NEW_ITEM(SSH2_FILE, handle, create, sf)

/* wrap a libSSH2 SFTP directory */
#define NEW_DIR(create) NEW_ITEM(SSH2_DIR, handle, create, sf)

/* wrap a libSSH2 public key object */
#define NEW_PUBLICKEY(create) NEW_ITEM(SSH2_PUBLICKEY, pkey, create, ss)

/* wrap a libSSH2 knownhosts object */
#define NEW_KNOWNHOSTS(create) NEW_ITEM(SSH2_KNOWNHOSTS, knownhosts, create, ss)

static void
set_cb_args(pTHX_ AV* data) {
    GV *gv = gv_fetchpv("Net::SSH2::_cb_args", 1, SVt_PV);
    SV *sv = save_scalar(gv);
    sv_setsv(sv, sv_2mortal(newRV_inc((SV*)data)));
}

static SV*
get_cb_arg(pTHX_ I32 ix) {
    SV *sv = get_sv("Net::SSH2::_cb_args", 1);
    if (SvROK(sv)) {
        AV *data = (AV*)SvRV(sv);
        if (SvTYPE(data) == SVt_PVAV) {
            SV **svp = av_fetch(data, ix, 0);
            if (svp && *svp)
                return *svp;
            Perl_croak(aTHX_ "internal error: unable to fetch callback data slot %d", ix);
        }
    }
    Perl_croak(aTHX_ "internal error: unexpected structure found for callback data");
}

/* callback for returning a password via "keyboard-interactive" auth */
static LIBSSH2_USERAUTH_KBDINT_RESPONSE_FUNC(cb_kbdint_response_password) {
    if (num_prompts != 1 || prompts[0].echo) {
        int i;
        for (i = 0; i < num_prompts; ++i) {
            responses[i].text = NULL;
            responses[i].length = 0;
        }
    }
    else {
        /* single prompt, no echo: assume it's a password request */
        dTHX;
        SV *password = get_cb_arg(aTHX_ 0);
        STRLEN len_password;
        const char* pv_password = SvPVbyte(password, len_password);

        responses[0].text = savepvn(pv_password, len_password);
        responses[0].length = len_password;
    }
}

/* thunk to call perl input-reading function for "keyboard-interactive" auth */
static LIBSSH2_USERAUTH_KBDINT_RESPONSE_FUNC(cb_kbdint_response_callback) {
    dTHX; dSP;
    int count, i;
    SV *cb = get_cb_arg(aTHX_ 0);
    SV *self = get_cb_arg(aTHX_ 1);
    SV *username = get_cb_arg(aTHX_ 2);

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    EXTEND(SP, 4 + num_prompts);
    PUSHs(self);
    PUSHs(username);
    PUSHs(sv_2mortal(newSVpvn(name, name_len)));
    PUSHs(sv_2mortal(newSVpvn(instruction, instruction_len)));
    for (i = 0; i < num_prompts; ++i) {
        HV* hv = newHV();
        /* Perl_warn(aTHX_ "prompt %d: text: %p, length: %d, echo: %d\n", */
        /* i, prompts[i].text, prompts[i].length, prompts[i].echo); */
        PUSHs(sv_2mortal(newRV_noinc((SV*)hv)));
        hv_store(hv, "text", 4, newSVpvn((const char *)prompts[i].text, prompts[i].length), 0);
        hv_store(hv, "echo", 4, newSVuv(prompts[i].echo), 0);
        responses[i].text = NULL;
        responses[i].length = 0;
    }
    PUTBACK;
    count = call_sv(cb, G_ARRAY);
    SPAGAIN;
    if (count > num_prompts) {
        Perl_warn(aTHX_ "Too many responses from callback, %d expected but %d found!",
                  num_prompts, count);
        while (count-- > num_prompts)
            POPs;
    }
    while (count-- > 0) {
        STRLEN len_response;
        SV *sv = POPs;
        char *pv_response = SvPVbyte(sv, len_response);
        responses[count].text = savepvn(pv_response, len_response);
        responses[count].length = len_response;
    }
    PUTBACK;
    FREETMPS;
    LEAVE;
}

/* thunk to call perl password change function for "password" auth */
static LIBSSH2_PASSWD_CHANGEREQ_FUNC(cb_password_change_callback) {
    dTHX; dSP;
    int count;
    SV *cb = get_cb_arg(aTHX_ 0);
    SV *self = get_cb_arg(aTHX_ 1);
    SV *username = get_cb_arg(aTHX_ 2);

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    XPUSHs(self);
    XPUSHs(username);
    PUTBACK;
    count = call_sv(cb, G_SCALAR);
    SPAGAIN;
    if (count > 0) {
        STRLEN len_password;
        const char* pv_password = SvPVbyte(POPs, len_password);
        *newpw = savepvn(pv_password, len_password);
        *newpw_len = len_password;
    }
    else {
        *newpw = NULL;
        *newpw_len = 0;
    }
    PUTBACK;
    FREETMPS;
    LEAVE;
}

/* thunk to call perl SSH_MSG_IGNORE packet function */
static LIBSSH2_IGNORE_FUNC(cb_ignore_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHp(message, message_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_IGNORE], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_DEBUG packet function */
static LIBSSH2_DEBUG_FUNC(cb_debug_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHi(always_display);
    mXPUSHp(message, message_len);
    mXPUSHp(language, language_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_DEBUG], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_DISCONNECT packet function */
static LIBSSH2_DISCONNECT_FUNC(cb_disconnect_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHi(reason);
    mXPUSHp(message, message_len);
    mXPUSHp(language, language_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_DISCONNECT], G_VOID);
    SPAGAIN; SP -= count; ax = (SP - PL_stack_base) + 1;

    PUTBACK; FREETMPS; LEAVE;
}

/* thunk to call perl SSH_MSG_MACERROR packet function */
static LIBSSH2_MACERROR_FUNC(cb_macerror_callback) {
    SSH2* ss = (SSH2*)*abstract;
    int ret = 0;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    mXPUSHp(packet, packet_len);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_MACERROR], G_SCALAR);
    SPAGAIN; SP -= count ; ax = (SP - PL_stack_base) + 1;

    if (count > 0)
        ret = SvIV(ST(0));
 
    PUTBACK; FREETMPS; LEAVE;
    return ret;
}

/* thunk to call perl X11 forwarder packet function */
static LIBSSH2_X11_OPEN_FUNC(cb_x11_open_callback) {
    SSH2* ss = (SSH2*)*abstract;

    dSP; I32 ax; int count;
    ENTER; SAVETMPS; PUSHMARK(SP);
    XPUSHs(sv_2mortal(newRV_inc(ss->sv_ss)));
    /*TODO: we actually need to push a channel here, but we don't know the
     *      SV of the channel (use a local hash?) */
    XPUSHs(&PL_sv_undef);
    mXPUSHp(shost, strlen(shost));
    mXPUSHi(sport);
    PUTBACK;

    count = call_sv(ss->rgsv_cb[LIBSSH2_CALLBACK_X11], G_VOID);
    SPAGAIN; SP -= count ; ax = (SP - PL_stack_base) + 1 ;

    PUTBACK; FREETMPS; LEAVE;
}

void * cb_as_void_ptr(void (*cb)()) {
    void * addr;
    memcpy(&addr, &cb, sizeof addr);
    return addr;
}

static void (*msg_cb[])() = {
    (void (*)())cb_ignore_callback,
    (void (*)())cb_debug_callback,
    (void (*)())cb_disconnect_callback,
    (void (*)())cb_macerror_callback,
    (void (*)())cb_x11_open_callback
};

#define MY_CXT_KEY "Net::SSH2::_guts" XS_VERSION

#ifdef HAVE_GCRYPT
#ifndef WIN32
GCRY_THREAD_OPTION_PTHREAD_IMPL;
#else
GCRY_THREAD_OPTION_PTH_IMPL;
#endif
#endif

typedef struct {
    HV* global_cb_data;
    UV tid;
} my_cxt_t;

START_MY_CXT

static UV get_my_thread_id(void) /* returns threads->tid() value */
{
    dSP;
    UV tid = 0;
    int count = 0;

#ifdef USE_ITHREADS
    ENTER;
    SAVETMPS;
    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSVpv("threads", 0)));
    PUTBACK;
    count = call_method("tid", G_SCALAR|G_EVAL);
    SPAGAIN;
    if (SvTRUE(ERRSV) || count != 1)
       /* if threads not loaded or an error occurs return 0 */
       tid = 0;
    else
       tid = (UV)POPi;
    PUTBACK;
    FREETMPS;
    LEAVE;
#endif

    return tid;
}

#if defined(USE_ITHREADS) && !defined(HAVE_GCRYPT)
/* IMPORTANT NOTE:
 * openssl locking was implemented according to http://www.openssl.org/docs/crypto/threads.html
 * we implement both static and dynamic locking as described on URL above
 * locking is supported when OPENSSL_THREADS macro is defined which means openssl-0.9.7 or newer
 * we intentionally do not implement cleanup of openssl's threading as it causes troubles
 * with apache-mpm-worker+mod_perl+mod_ssl+net-ssleay
 */

static perl_mutex *GLOBAL_openssl_mutex = NULL;

static void openssl_locking_function(int mode, int type, const char *file, int line)
{
    if (!GLOBAL_openssl_mutex) return;
    if (mode & CRYPTO_LOCK)
      MUTEX_LOCK(&GLOBAL_openssl_mutex[type]);
    else
      MUTEX_UNLOCK(&GLOBAL_openssl_mutex[type]);
}

#if OPENSSL_VERSION_NUMBER < 0x10000000L
static unsigned long openssl_threadid_func(void)
{
    dMY_CXT;
    return (unsigned long)(MY_CXT.tid);
}
#else
static void openssl_threadid_func(CRYPTO_THREADID *id)
{
    dMY_CXT;
    CRYPTO_THREADID_set_numeric(id, (unsigned long)(MY_CXT.tid));
}
#endif

struct CRYPTO_dynlock_value
{
    perl_mutex mutex;
};

static struct CRYPTO_dynlock_value *openssl_dynlocking_create_function(const char *file, int line)
{
    struct CRYPTO_dynlock_value *retval;
    New(0, retval, 1, struct CRYPTO_dynlock_value);
    if (!retval) return NULL;
    MUTEX_INIT(&retval->mutex);
    return retval;
}

static void openssl_dynlocking_lock_function(int mode, struct CRYPTO_dynlock_value *l, const char *file, int line)
{
    if (!l) return;
    if (mode & CRYPTO_LOCK)
      MUTEX_LOCK(&l->mutex);
    else
      MUTEX_UNLOCK(&l->mutex);
}

static void openssl_dynlocking_destroy_function(struct CRYPTO_dynlock_value *l, const char *file, int line)
{
    if (!l) return;
    MUTEX_DESTROY(&l->mutex);
    Safefree(l);
}

static void openssl_threads_init(void)
{
    int i;

    /* initialize static locking */
    if ( !CRYPTO_get_locking_callback() ) {
#if OPENSSL_VERSION_NUMBER < 0x10000000L
        if ( !CRYPTO_get_id_callback() ) {
#else
        if ( !CRYPTO_THREADID_get_callback() ) {
#endif
            New(0, GLOBAL_openssl_mutex, CRYPTO_num_locks(), perl_mutex);
            if (!GLOBAL_openssl_mutex) return;
            for (i=0; i<CRYPTO_num_locks(); i++) MUTEX_INIT(&GLOBAL_openssl_mutex[i]);
            CRYPTO_set_locking_callback(openssl_locking_function);

#ifndef WIN32
            /* no need for threadid_func() on Win32 */
#if OPENSSL_VERSION_NUMBER < 0x10000000L
            CRYPTO_set_id_callback(openssl_threadid_func);
#else
            CRYPTO_THREADID_set_callback(openssl_threadid_func);
#endif
#endif
        }
    }

    /* initialize dynamic locking */
    if ( !CRYPTO_get_dynlock_create_callback() &&
         !CRYPTO_get_dynlock_lock_callback() &&
         !CRYPTO_get_dynlock_destroy_callback() ) {
        CRYPTO_set_dynlock_create_callback(openssl_dynlocking_create_function);
        CRYPTO_set_dynlock_lock_callback(openssl_dynlocking_lock_function);
        CRYPTO_set_dynlock_destroy_callback(openssl_dynlocking_destroy_function);
    }
}

#else

/* no threads */
static void openssl_threads_init(void)
{
}

#endif

static void
croak_last_error(SSH2 *ss, const char *class, const char *method) {
    char *errmsg = NULL;
    int err = libssh2_session_last_error(ss->session, &errmsg, NULL, 0);
    croak("%s::%s: %s (%d)", class, method, errmsg, err);
}

#define CROAK_LAST_ERROR(session, method) (croak_last_error((session), class, (method)))

#if LIBSSH2_VERSION_NUM < 0x010601
#define libssh2_session_set_last_error(ss, errcode, errmsg)   0
#endif

static void
save_eagain(LIBSSH2_SESSION *session, int error) {
    if (error == LIBSSH2_ERROR_EAGAIN)
        libssh2_session_set_last_error(session, LIBSSH2_ERROR_EAGAIN, "Operation would block");
}

/* perl module exports */

#line 863 "SSH2.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1007 "SSH2.c"

/* INCLUDE:  Including 'const-xs.inc' from 'SSH2.xs' */


XS_EUPXS(XS_Net__SSH2_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_constant)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4 "./const-xs.inc"
#ifdef dXSTARG
	dXSTARG; /* Faster if we have it.  */
#else
	dTARGET;
#endif
	STRLEN		len;
        int		type;
	IV		iv = 0; /* avoid uninit var warning */
	/* NV		nv;	Uncomment this if you need to return NVs */
	/* const char	*pv;	Uncomment this if you need to return PVs */
#line 1032 "SSH2.c"
	SV *	sv = ST(0)
;
	const char *	s = SvPV(sv, len);
#line 18 "./const-xs.inc"
        /* Change this to constant(aTHX_ s, len, &iv, &nv);
           if you need to return both NVs and IVs */
	type = constant(aTHX_ s, len, &iv);
      /* Return 1 or 2 items. First is error message, or undef if no error.
           Second, if present, is found value */
        switch (type) {
        case PERL_constant_NOTFOUND:
          sv =
	    sv_2mortal(newSVpvf("%s is not a valid Net::SSH2 macro", s));
          PUSHs(sv);
          break;
        case PERL_constant_NOTDEF:
          sv = sv_2mortal(newSVpvf(
	    "Your vendor has not defined Net::SSH2 macro %s, used",
				   s));
          PUSHs(sv);
          break;
        case PERL_constant_ISIV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHi(iv);
          break;
	/* Uncomment this if you need to return NOs
        case PERL_constant_ISNO:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_no);
          break; */
	/* Uncomment this if you need to return NVs
        case PERL_constant_ISNV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHn(nv);
          break; */
	/* Uncomment this if you need to return PVs
        case PERL_constant_ISPV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, strlen(pv));
          break; */
	/* Uncomment this if you need to return PVNs
        case PERL_constant_ISPVN:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHp(pv, iv);
          break; */
	/* Uncomment this if you need to return SVs
        case PERL_constant_ISSV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(sv);
          break; */
	/* Uncomment this if you need to return UNDEFs
        case PERL_constant_ISUNDEF:
          break; */
	/* Uncomment this if you need to return UVs
        case PERL_constant_ISUV:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHu((UV)iv);
          break; */
	/* Uncomment this if you need to return YESs
        case PERL_constant_ISYES:
          EXTEND(SP, 2);
          PUSHs(&PL_sv_undef);
          PUSHs(&PL_sv_yes);
          break; */
        default:
          sv = sv_2mortal(newSVpvf(
	    "Unexpected return type %d while processing Net::SSH2 macro %s, used",
               type, s));
          PUSHs(sv);
        }
#line 1110 "SSH2.c"
	PUTBACK;
	return;
    }
}


/* INCLUDE: Returning to 'SSH2.xs' from 'const-xs.inc' */

#define class "Net::SSH2"

XS_EUPXS(XS_Net__SSH2_CLONE); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_CLONE)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
#line 889 "SSH2.xs"
    MY_CXT_CLONE;
    MY_CXT.global_cb_data = newHV();
    MY_CXT.tid = get_my_thread_id();
    debug("%s::CLONE: tid=%d my_perl=0x%p\n", class, MY_CXT.tid, my_perl);
#line 1133 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__parse_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__parse_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "prefix, value");
    {
	IV	RETVAL;
	dXSTARG;
	char *    prefix = (char *)SvPV_nolen(ST(0))
;
	SV *	value = ST(1)
;
#line 897 "SSH2.xs"
    RETVAL = sv2iv_constant_or_croak(prefix, value);
#line 1154 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "proto");
    {
	SSH2 *	RETVAL;
	SV*	proto = ST(0)
;
#line 904 "SSH2.xs"
    Newz(0/*id*/, RETVAL, 1, SSH2);
    if (RETVAL) {
        RETVAL->session = libssh2_session_init_ex(
         local_alloc, local_free, local_realloc, RETVAL);
    }
    if (!RETVAL || !RETVAL->session) {
        Safefree(RETVAL);
        XSRETURN_EMPTY;
    }
    debug("Net::SSH2: created new object 0x%x\n", RETVAL);
#line 1182 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Net::SSH2", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_trace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_trace)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, bitmask");
    {
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_trace"))
;
	IV	bitmask = (IV)SvIV(ST(1))
;
#line 920 "SSH2.xs"
    libssh2_trace(ss->session, bitmask);
#line 1207 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#if LIBSSH2_VERSION_MAJOR >= 1
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Net__SSH2_block_directions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_block_directions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	IV	RETVAL;
	dXSTARG;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_block_directions"))
;
#line 927 "SSH2.xs"
    RETVAL = libssh2_session_block_directions(ss->session);
#line 1229 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Net__SSH2_block_directions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_block_directions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_block_directions"))
;
#line 936 "SSH2.xs"
    croak("libssh2 version 1.0 or higher required for block_directions support");
#line 1250 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif
#if LIBSSH2_VERSION_NUM >= 0x010209
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Net__SSH2_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_timeout)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ss, timeout= &PL_sv_undef");
    {
#line 945 "SSH2.xs"
    long r;
#line 1269 "SSH2.c"
	SV *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_timeout"))
;
	SV *	timeout;

	if (items < 2)
	    timeout = &PL_sv_undef;
	else {
	    timeout = ST(1)
;
	}
#line 947 "SSH2.xs"
    if (items > 1)
        libssh2_session_set_timeout(ss->session,
                                    (SvOK(timeout) ? SvUV(timeout) : 0));
    r = libssh2_session_get_timeout(ss->session);
    RETVAL = (r > 0 ? newSVuv(r) : &PL_sv_undef);
#line 1287 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_Net__SSH2_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, timeout");
    {
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_timeout"))
;
	long    timeout = SV2TYPE(ST(1), long)
;
#line 960 "SSH2.xs"
    croak("libssh2 version 1.2.9 or higher required for set_timeout support");
#line 1311 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_blocking); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_blocking)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ss, blocking= 0");
    {
	SSH2_BOOL	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_blocking"))
;
	SSH2_BOOL	blocking;

	if (items < 2)
	    blocking = 0;
	else {
    blocking = SvTRUE(ST(1))
;
	}
#line 967 "SSH2.xs"
    if (items > 1)
        libssh2_session_set_blocking(ss->session, blocking);
    RETVAL = libssh2_session_get_blocking(ss->session);
#line 1340 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ((RETVAL) ? &PL_sv_yes : &PL_sv_no);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_DESTROY"))
;
#line 976 "SSH2.xs"
    debug("%s::DESTROY object 0x%x\n", class, ss);
    libssh2_session_free(ss->session);
    if (ss->socket)
        SvREFCNT_dec(ss->socket);
    if (ss->hostname)
        SvREFCNT_dec(ss->hostname);
    Safefree(ss);
#line 1369 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_debug)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "SV*, debug");
    {
	IV	debug = (IV)SvIV(ST(1))
;
#line 987 "SSH2.xs"
    net_ss_debug_out = debug & 1;  /* allow for future flags */
#line 1386 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_version)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 992 "SSH2.xs"
    EXTEND(SP, 3);
    ST(0) = sv_2mortal(newSVpv(LIBSSH2_VERSION, 0));
    if (GIMME_V != G_ARRAY)
        XSRETURN(1);
#ifdef LIBSSH2_VERSION_NUM
    ST(1) = sv_2mortal(newSVuv(LIBSSH2_VERSION_NUM));
#else
    ST(1) = &PL_sv_undef;
#endif
    ST(2) = sv_2mortal(newSVpv(LIBSSH2_SSH_DEFAULT_BANNER, 0));
    XSRETURN(3);
#line 1413 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2_banner); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_banner)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, banner");
    {
#line 1007 "SSH2.xs"
    SV* full_banner;
#line 1429 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_banner"))
;
	SSH2_CHARP    banner = SvPVbyte_nolen(ST(1))
;
#line 1009 "SSH2.xs"
    full_banner = sv_2mortal(newSVpvf("SSH-2.0-%s", banner));
    RETVAL = libssh2_banner_set(ss->session, SvPVbyte_nolen(full_banner));
    save_eagain(ss->session, RETVAL);
#line 1439 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
#line 1018 "SSH2.xs"
    char* errstr;
    int errlen;
#line 1461 "SSH2.c"
	SSH2_ERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_error"))
;
#line 1021 "SSH2.xs"
    RETVAL = libssh2_session_last_error(ss->session, &errstr, &errlen, 0);
    if(GIMME_V == G_ARRAY) {
        SV *errcode_sv;
        if (RETVAL == LIBSSH2_ERROR_NONE)
            XSRETURN_EMPTY;
        EXTEND(SP, 3);
        ST(0) = sv_2mortal(newSViv(RETVAL));
        if ((-RETVAL > 0) && (-RETVAL < countof(xs_libssh2_error)))
            errcode_sv = newSVpvf("LIBSSH2_ERROR_%s", xs_libssh2_error[-RETVAL]);
        else
            errcode_sv = newSVpvf("LIBSSH2_ERROR_UNKNOWN(%d)", RETVAL);
        ST(1) = sv_2mortal(errcode_sv);
        ST(2) = (errstr ? sv_2mortal(newSVpvn(errstr, errlen)) : &PL_sv_undef);
        XSRETURN(3);
    }
#line 1481 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = newSViv(RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__set_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__set_error)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "ss, errcode= 0, errmsg= NULL");
    {
	SSH2 *    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__set_error"))
;
	int	errcode;
	SSH2_CHARP_OR_NULL	errmsg;

	if (items < 2)
	    errcode = 0;
	else {
	    errcode = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    errmsg = NULL;
	else {
    errmsg = (SvOK(ST(2)) ? SvPVbyte_nolen(ST(2)) : NULL)
;
	}
#line 1042 "SSH2.xs"
    libssh2_session_set_last_error(ss->session, errcode, errmsg);
#line 1520 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__method); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__method)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ss, type, prefs= NULL");
    {
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__method"))
;
	SSH2_METHOD    type = sv2iv_constant_or_croak("METHOD", ST(1))
;
	SSH2_CHARP_OR_NULL	prefs;

	if (items < 3)
	    prefs = NULL;
	else {
    prefs = (SvOK(ST(2)) ? SvPVbyte_nolen(ST(2)) : NULL)
;
	}
#line 1047 "SSH2.xs"
    /* if there are no other parameters, return the current value */
    if (items == 2) {
        const char *method = libssh2_session_methods(ss->session, (int)type);
        if (!method)
            XSRETURN_EMPTY;
        XSRETURN_PV(method);
    }
    RETVAL = libssh2_session_method_pref(ss->session,
                                         (int)type, prefs);
    save_eagain(ss->session, RETVAL);
#line 1557 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAE 1


XS_EUPXS(XS_Net__SSH2_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_flag)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, flag, value");
    {
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_flag"))
;
	SSH2_FLAG    flag = sv2iv_constant_or_croak("FLAG", ST(1))
;
	int	value = (int)SvIV(ST(2))
;
#line 1065 "SSH2.xs"
    RETVAL = libssh2_session_flag(ss->session, (int)flag, value);
    save_eagain(ss->session, RETVAL);
#line 1589 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAF 1


XS_EUPXS(XS_Net__SSH2_flag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_flag)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, flag, value");
    {
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_flag"))
;
	SV*	flag = ST(1)
;
	int	value = (int)SvIV(ST(2))
;
#line 1075 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for flag support");
#line 1619 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_callback)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ss, type, callback= NULL");
    {
	SSH2_RC	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_callback"))
;
	SSH2_CALLBACK    type = sv2iv_constant_or_croak("CALLBACK", ST(1))
;
	SV*	callback;

	if (items < 3)
	    callback = NULL;
	else {
	    callback = ST(2)
;
	}
#line 1082 "SSH2.xs"
    if (callback && !SvOK(callback))
        callback = NULL;
    if (callback && !(SvROK(callback) && SvTYPE(SvRV(callback)) == SVt_PVCV))
        croak("%s::callback: callback must be CODE ref", class);
    if (type < 0 || type >= countof(msg_cb))
        croak("%s::callback: don't know how to handle: %s",
              class, SvPVbyte_nolen(callback));

    ss->sv_ss = SvRV(ST(0));  /* don't keep a reference, just store it */
    SvREFCNT_dec(ss->rgsv_cb[type]);
    libssh2_session_callback_set(ss->session,
     type, callback ? cb_as_void_ptr(msg_cb[type]) : NULL);
    SvREFCNT_inc(callback);
    ss->rgsv_cb[type] = callback;
    RETVAL = 1;
#line 1662 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ((RETVAL) ? &PL_sv_yes : &PL_sv_undef);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__startup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__startup)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "ss, fd, socket, hostname, port");
    {
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__startup"))
;
	int	fd = (int)SvIV(ST(1))
;
	SV *	socket = ST(2)
;
	SV*	hostname = ST(3)
;
	int	port = (int)SvIV(ST(4))
;
#line 1103 "SSH2.xs"
    RETVAL = libssh2_session_startup(ss->session, fd);
    if ((RETVAL >= 0) && SvOK(socket)) {
        if (ss->socket)
            sv_2mortal(ss->socket);
        ss->socket = newSVsv(socket);
        ss->hostname = newSVsv(hostname);
        ss->port = port;
    }
    save_eagain(ss->session, RETVAL);
#line 1702 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_hostname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_hostname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SV *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_hostname"))
;
#line 1118 "SSH2.xs"
    RETVAL = (ss->hostname ? newSVsv(ss->hostname) : &PL_sv_undef);
#line 1726 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_port); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_port)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	int	RETVAL;
	dXSTARG;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_port"))
;
#line 1125 "SSH2.xs"
    RETVAL = ss->port;
#line 1747 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_sock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_sock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SV *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_sock"))
;
#line 1132 "SSH2.xs"
    RETVAL = (ss->socket ? newSVsv(ss->socket) : &PL_sv_undef);
#line 1766 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_disconnect)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "ss, description= \"\", reason= SSH_DISCONNECT_BY_APPLICATION, lang= \"\"");
    {
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_disconnect"))
;
	SSH2_CHARP	description;
	int	reason;
	SSH2_CHARP	lang;

	if (items < 2)
	    description = "";
	else {
    description = SvPVbyte_nolen(ST(1))
;
	}

	if (items < 3)
	    reason = SSH_DISCONNECT_BY_APPLICATION;
	else {
	    reason = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    lang = "";
	else {
    lang = SvPVbyte_nolen(ST(3))
;
	}
#line 1140 "SSH2.xs"
    RETVAL = libssh2_session_disconnect_ex(ss->session, reason, description, lang);
    save_eagain(ss->session, RETVAL);
#line 1811 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_hostkey_hash); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_hostkey_hash)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, type");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1148 "SSH2.xs"
    const char* hash;
    static STRLEN rglen[] = { 16/*MD5*/, 20/*SHA1*/ };
#line 1835 "SSH2.c"
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_hostkey_hash"))
;
	SSH2_HOSTKEY_HASH    type = sv2iv_constant_or_croak("HOSTKEY_HASH", ST(1))
;
#line 1151 "SSH2.xs"
    if (type < 1 || type > countof(rglen)) {
        croak("%s::hostkey: unknown hostkey hash: %d",
              class, (int)type);
    }
    if ((hash = (const char*)libssh2_hostkey_hash(ss->session, type))) {
        PUSHs(sv_2mortal(newSVpvn(hash, rglen[type-1])));
        XSRETURN(1);
    }
    XSRETURN_EMPTY;
#line 1850 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2_remote_hostkey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_remote_hostkey)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1164 "SSH2.xs"
    const char *key_pv;
    size_t key_len;
    int type_int;
#line 1870 "SSH2.c"
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_remote_hostkey"))
;
#line 1168 "SSH2.xs"
    if ((key_pv = libssh2_session_hostkey(ss->session, &key_len, &type_int))) {
        XPUSHs(sv_2mortal(newSVpvn(key_pv, key_len)));
        if (GIMME_V != G_ARRAY)
            XSRETURN(1);
        else {
            XPUSHs(sv_2mortal(newSViv(type_int)));
            XSRETURN(2);
        }
    }
    else
        XSRETURN_EMPTY;
#line 1885 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__auth_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__auth_list)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ss, username= &PL_sv_undef");
    {
#line 1183 "SSH2.xs"
    const char* pv_username = NULL;
    STRLEN len_username = 0;
#line 1902 "SSH2.c"
	SSH2_CHARP_OR_NULL	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__auth_list"))
;
	SV *	username;

	if (items < 2)
	    username = &PL_sv_undef;
	else {
	    username = ST(1)
;
	}
#line 1186 "SSH2.xs"
    if (SvOK(username))
        pv_username = SvPVbyte(username, len_username);
    RETVAL = libssh2_userauth_list(ss->session, pv_username, len_username);
#line 1918 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = (RETVAL ? newSVpv(RETVAL, 0) : &PL_sv_undef);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_auth_ok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_ok)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2_RC	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_ok"))
;
#line 1195 "SSH2.xs"
    RETVAL = libssh2_userauth_authenticated(ss->session);
#line 1942 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ((RETVAL) ? &PL_sv_yes : &PL_sv_undef);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_auth_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_password)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "ss, username, password= &PL_sv_undef, callback= &PL_sv_undef");
    {
#line 1204 "SSH2.xs"
    STRLEN len_username, len_password;
    const char *pv_username, *pv_password;
    int i, ok;
#line 1965 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_password"))
;
	SV*	username = ST(1)
;
	SV*	password;
	SV*	callback;

	if (items < 3)
	    password = &PL_sv_undef;
	else {
	    password = ST(2)
;
	}

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3)
;
	}
#line 1208 "SSH2.xs"
    pv_username = SvPVbyte(username, len_username);

    /* if we don't have a password, try for an unauthenticated login */
    if (!SvPOK(password)) {
        /* That's how libssh2 tells you authentication 'none' is valid */
        RETVAL = (((libssh2_userauth_list(ss->session, pv_username, len_username) == NULL) &&
                   libssh2_userauth_authenticated(ss->session)) ? 0 : -1);
    }
    else {
        if (SvOK(callback)) {
            if (!(SvROK(callback) && SvTYPE(SvRV(callback)) == SVt_PVCV))
                Perl_croak(aTHX_ "%s::auth_password: callback must be CODE ref", class);
            else {
                AV *cb_args = (AV*)sv_2mortal((SV*)newAV());
                av_push(cb_args, newSVsv(callback));
                av_push(cb_args, newSVsv(ST(0))); /*session */
                av_push(cb_args, newSVsv(username));
                set_cb_args(aTHX_ cb_args);
            }
        }

        pv_password = SvPVbyte(password, len_password);
        RETVAL = libssh2_userauth_password_ex(ss->session,
                                              pv_username, len_username,
                                              pv_password, len_password,
                                              (SvOK(callback) ? cb_password_change_callback : NULL));
        save_eagain(ss->session, RETVAL);
    }
#line 2016 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010203
#define XSubPPtmpAAAG 1


XS_EUPXS(XS_Net__SSH2_auth_agent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_agent)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, username");
    {
#line 1244 "SSH2.xs"
    LIBSSH2_AGENT *agent;
    int old_blocking;
#line 2041 "SSH2.c"
	SV *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_agent"))
;
	SSH2_CHARP    username = SvPVbyte_nolen(ST(1))
;
#line 1247 "SSH2.xs"
    RETVAL = &PL_sv_undef;
    /* unfortunatelly this can't be make to work on nb mode */
    old_blocking = libssh2_session_get_blocking(ss->session);
    libssh2_session_set_blocking(ss->session, 1);
    if ((agent = libssh2_agent_init(ss->session)) != NULL) {
        if (libssh2_agent_connect(agent) == LIBSSH2_ERROR_NONE) {
            if (libssh2_agent_list_identities(agent) == LIBSSH2_ERROR_NONE) {
                struct libssh2_agent_publickey *identity = NULL;
                while (libssh2_agent_get_identity(agent, &identity, identity) == 0) {
                    if (libssh2_agent_userauth(agent, username, identity) == LIBSSH2_ERROR_NONE) {
                        RETVAL = &PL_sv_yes;
                        break;
                    }
                }
            }
        }
        libssh2_agent_free(agent);
    }
    libssh2_session_set_blocking(ss->session, old_blocking);
#line 2067 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAH 1


XS_EUPXS(XS_Net__SSH2_auth_agent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_agent)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ss, username");
    {
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_agent"))
;
	SV*	username = ST(1)
;
#line 1274 "SSH2.xs"
    croak("libssh2 version 1.2.3 or higher required for agent support");
#line 2091 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_auth_publickey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_publickey)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "ss, username, publickey, privatekey, passphrase= NULL");
    {
#line 1282 "SSH2.xs"
    const char* pv_username;
    STRLEN len_username;
#line 2108 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_publickey"))
;
	SV*	username = ST(1)
;
	SSH2_CHARP_OR_NULL    publickey = (SvOK(ST(2)) ? SvPVbyte_nolen(ST(2)) : NULL)
;
	SSH2_CHARP    privatekey = SvPVbyte_nolen(ST(3))
;
	SSH2_CHARP_OR_NULL	passphrase;

	if (items < 5)
	    passphrase = NULL;
	else {
    passphrase = (SvOK(ST(4)) ? SvPVbyte_nolen(ST(4)) : NULL)
;
	}
#line 1285 "SSH2.xs"
    pv_username = SvPVbyte(username, len_username);
    RETVAL = libssh2_userauth_publickey_fromfile_ex(ss->session,
                                                    pv_username, len_username,
                                                    publickey, privatekey,
                                                    passphrase);
    save_eagain(ss->session, RETVAL);
#line 2133 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010600
#define XSubPPtmpAAAI 1


XS_EUPXS(XS_Net__SSH2_auth_publickey_frommemory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_publickey_frommemory)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "ss, username, publickey, privatekey, passphrase= NULL");
    {
#line 1300 "SSH2.xs"
    const char *pv_username, *pv_publickey, *pv_privatekey;
    STRLEN len_username, len_publickey, len_privatekey;
#line 2158 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_publickey_frommemory"))
;
	SV*	username = ST(1)
;
	SV*	publickey = ST(2)
;
	SV*	privatekey = ST(3)
;
	SSH2_CHARP_OR_NULL	passphrase;

	if (items < 5)
	    passphrase = NULL;
	else {
    passphrase = (SvOK(ST(4)) ? SvPVbyte_nolen(ST(4)) : NULL)
;
	}
#line 1303 "SSH2.xs"
    pv_username = SvPVbyte(username, len_username);
    pv_publickey = SvPVbyte(publickey, len_publickey);
    pv_privatekey = SvPVbyte(privatekey, len_privatekey);

    RETVAL = libssh2_userauth_publickey_frommemory(ss->session,
                                                   pv_username, len_username, pv_publickey, len_publickey,
                                                   pv_privatekey, len_privatekey,
                                                   passphrase);
    save_eagain(ss->session, RETVAL);
#line 2186 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__SSH2_auth_hostbased); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_hostbased)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "ss, username, publickey, privatekey, hostname, local_username= &PL_sv_undef, passphrase= NULL");
    {
#line 1323 "SSH2.xs"
    const char* pv_username, * pv_hostname, * pv_local_username;
    STRLEN len_username, len_hostname, len_local_username;
#line 2209 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_hostbased"))
;
	SV*	username = ST(1)
;
	const char*    publickey = (const char *)SvPV_nolen(ST(2))
;
	const char*    privatekey = (const char *)SvPV_nolen(ST(3))
;
	SV*	hostname = ST(4)
;
	SV*	local_username;
	SSH2_CHARP_OR_NULL	passphrase;

	if (items < 6)
	    local_username = &PL_sv_undef;
	else {
	    local_username = ST(5)
;
	}

	if (items < 7)
	    passphrase = NULL;
	else {
    passphrase = (SvOK(ST(6)) ? SvPVbyte_nolen(ST(6)) : NULL)
;
	}
#line 1326 "SSH2.xs"
    pv_username = SvPVbyte(username, len_username);
    pv_hostname = SvPVbyte(hostname, len_hostname);

    if (SvPOK(local_username)) {
        pv_local_username = SvPVbyte(local_username, len_local_username);
    }
    else {
        pv_local_username = pv_username;
        len_local_username = len_username;
    }
    RETVAL = libssh2_userauth_hostbased_fromfile_ex(ss->session,
                                                    pv_username, len_username, publickey, privatekey,
                                                    passphrase,
                                                    pv_hostname, len_hostname,
                                                    pv_local_username, len_local_username);
    save_eagain(ss->session, RETVAL);
#line 2254 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_auth_keyboard); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_auth_keyboard)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ss, username, password= NULL");
    {
#line 1348 "SSH2.xs"
    const char* pv_username;
    STRLEN len_username;
    AV *cb_args;
#line 2277 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_auth_keyboard"))
;
	SV*	username = ST(1)
;
	SV*	password;

	if (items < 3)
	    password = NULL;
	else {
	    password = ST(2)
;
	}
#line 1352 "SSH2.xs"
    pv_username = SvPVbyte(username, len_username);

    /* we either have a password, or a reference to a callback */

    if (!password || !SvOK(password)) {
        password = sv_2mortal(newRV_inc((SV*)get_cv("Net::SSH2::_cb_kbdint_response_default", 1)));
        if (!SvOK(password))
            Perl_croak(aTHX_ "Internal error: unable to retrieve callback");
    }

    cb_args = (AV*)sv_2mortal((SV*)newAV());
    av_push(cb_args, newSVsv(password));
    av_push(cb_args, newSVsv(ST(0))); /*session */
    av_push(cb_args, newSVsv(username));
    set_cb_args(aTHX_ cb_args);

    if (SvROK(password) && (SvTYPE(SvRV(password)) == SVt_PVCV))
        RETVAL = libssh2_userauth_keyboard_interactive_ex(ss->session,
                                                          pv_username, len_username,
                                                          cb_kbdint_response_callback);
    else
        RETVAL = libssh2_userauth_keyboard_interactive_ex(ss->session,
                                                          pv_username, len_username,
                                                          cb_kbdint_response_password);
    save_eagain(ss->session, RETVAL);
#line 2317 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010205
#define XSubPPtmpAAAJ 1


XS_EUPXS(XS_Net__SSH2_keepalive_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_config)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, want_reply, interval");
    {
	SSH2 *    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_keepalive_config"))
;
	int	want_reply = (int)SvIV(ST(1))
;
	unsigned int	interval = (unsigned int)SvUV(ST(2))
;
#line 1385 "SSH2.xs"
    libssh2_keepalive_config(ss->session, want_reply, interval);
#line 2347 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_keepalive_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_send)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
#line 1390 "SSH2.xs"
    int seconds_to_next;
#line 2362 "SSH2.c"
	SSH2_BYTES	RETVAL;
	SSH2 *    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_keepalive_send"))
;
#line 1392 "SSH2.xs"
    RETVAL = libssh2_keepalive_send(ss->session, &seconds_to_next);
    save_eagain(ss->session, RETVAL);
    if (RETVAL >= 0) RETVAL = seconds_to_next;
#line 2370 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAK 1


XS_EUPXS(XS_Net__SSH2_keepalive_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_config)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, want_reply, interval");
    {
	SSH2 *    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_keepalive_config"))
;
	int	want_reply = (int)SvIV(ST(1))
;
	unsigned int	interval = (unsigned int)SvUV(ST(2))
;
#line 1403 "SSH2.xs"
    croak("libssh2 version 1.2.5 or higher required for keepalive_config support");
#line 2400 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_keepalive_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_keepalive_send)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2 *    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_keepalive_send"))
;
#line 1408 "SSH2.xs"
    croak("libssh2 version 1.2.5 or higher required for keepalive_send support");
#line 2417 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2_channel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_channel)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "ss, channel_type= NULL, window_size= LIBSSH2_CHANNEL_WINDOW_DEFAULT, packet_size= LIBSSH2_CHANNEL_PACKET_DEFAULT");
    {
#line 1417 "SSH2.xs"
    static const char mandatory_type[] = "session";
#line 2433 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_channel"))
;
	SSH2_CHARP_OR_NULL	channel_type;
	int	window_size;
	int	packet_size;

	if (items < 2)
	    channel_type = NULL;
	else {
    channel_type = (SvOK(ST(1)) ? SvPVbyte_nolen(ST(1)) : NULL)
;
	}

	if (items < 3)
	    window_size = LIBSSH2_CHANNEL_WINDOW_DEFAULT;
	else {
	    window_size = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    packet_size = LIBSSH2_CHANNEL_PACKET_DEFAULT;
	else {
	    packet_size = (int)SvIV(ST(3))
;
	}
#line 1419 "SSH2.xs"
    if (channel_type && strcmp(channel_type, mandatory_type))
        Perl_croak(aTHX_ "channel_type must be 'session' ('%s' given)", channel_type);
    NEW_CHANNEL(libssh2_channel_open_ex(ss->session,
        mandatory_type, strlen(mandatory_type), window_size, packet_size,
        NULL/*message*/, 0/*message_len*/));
#line 2467 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::Channel", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x10601
#define XSubPPtmpAAAL 1


XS_EUPXS(XS_Net__SSH2__scp_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__scp_get)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, path, stat");
    {
#line 1432 "SSH2.xs"
    libssh2_struct_stat st;
#line 2491 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__scp_get"))
;
	SSH2_CHARP    path = SvPVbyte_nolen(ST(1))
;
	HV*	stat;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    stat = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::SSH2::_scp_get",
				"stat");
		}
	} STMT_END
;
#line 1434 "SSH2.xs"
    NEW_CHANNEL(libssh2_scp_recv2(ss->session, path, &st));
    hv_store(stat, "mode",  4, newSVuv(st.st_mode),  0/*hash*/);
    hv_store(stat, "uid",   3, newSVuv(st.st_uid),   0/*hash*/);
    hv_store(stat, "gid",   3, newSVuv(st.st_gid),   0/*hash*/);
#if IVSIZE >= 8
    hv_store(stat, "size",  4, newSVuv(st.st_size),  0/*hash*/);
#else
    hv_store(stat, "size",  4, newSVnv(st.st_size),  0/*hash*/);
#endif
    hv_store(stat, "atime", 5, newSVuv((time_t)st.st_atime), 0/*hash*/);
    hv_store(stat, "mtime", 5, newSVuv((time_t)st.st_mtime), 0/*hash*/);
#line 2524 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::Channel", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAM 1


XS_EUPXS(XS_Net__SSH2__scp_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__scp_get)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, path, stat");
    {
#line 1453 "SSH2.xs"
    struct stat st;
#line 2548 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__scp_get"))
;
	SSH2_CHARP    path = SvPVbyte_nolen(ST(1))
;
	HV*	stat;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    stat = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Net::SSH2::_scp_get",
				"stat");
		}
	} STMT_END
;
#line 1455 "SSH2.xs"
    NEW_CHANNEL(libssh2_scp_recv(ss->session, path, &st));
    hv_store(stat, "mode",  4, newSVuv(st.st_mode),  0/*hash*/);
    hv_store(stat, "uid",   3, newSVuv(st.st_uid),   0/*hash*/);
    hv_store(stat, "gid",   3, newSVuv(st.st_gid),   0/*hash*/);
    hv_store(stat, "size",  4, newSVuv(st.st_size),  0/*hash*/);
    hv_store(stat, "atime", 5, newSVuv((time_t)st.st_atime), 0/*hash*/);
    hv_store(stat, "mtime", 5, newSVuv((time_t)st.st_mtime), 0/*hash*/);
#line 2577 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::Channel", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif
#if LIBSSH2_VERSION_NUM >= 0x10206
#define XSubPPtmpAAAN 1


XS_EUPXS(XS_Net__SSH2__scp_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__scp_put)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "ss, path, mode, size, mtime= 0, atime= 0");
    {
	SSH2_CHANNEL *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__scp_put"))
;
	SSH2_CHARP    path = SvPVbyte_nolen(ST(1))
;
	int	mode = (int)SvIV(ST(2))
;
	SSH2_BYTESU64    size = SV2UTYPE(ST(3), SSH2_BYTESU64)
;
	time_t	mtime;
	time_t	atime;

	if (items < 5)
	    mtime = 0;
	else {
    mtime = SV2TYPE(ST(4), time_t)
;
	}

	if (items < 6)
	    atime = 0;
	else {
    atime = SV2TYPE(ST(5), time_t)
;
	}
#line 1473 "SSH2.xs"
    NEW_CHANNEL(libssh2_scp_send64(ss->session,
                                   path, mode, size, mtime, atime));
#line 2628 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::Channel", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAO 1


XS_EUPXS(XS_Net__SSH2__scp_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__scp_put)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "ss, path, mode, size, mtime= 0, atime= 0");
    {
	SSH2_CHANNEL *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__scp_put"))
;
	SSH2_CHARP    path = SvPVbyte_nolen(ST(1))
;
	int	mode = (int)SvIV(ST(2))
;
	size_t    size = SV2TYPE(ST(3), size_t)
;
	long	mtime;
	long	atime;

	if (items < 5)
	    mtime = 0;
	else {
    mtime = SV2TYPE(ST(4), long)
;
	}

	if (items < 6)
	    atime = 0;
	else {
    atime = SV2TYPE(ST(5), long)
;
	}
#line 1483 "SSH2.xs"
    NEW_CHANNEL(libssh2_scp_send_ex(ss->session,
                                    path, mode, size, mtime, atime));
#line 2678 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::Channel", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Net__SSH2_tcpip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_tcpip)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "ss, host, port, shost= \"127.0.0.1\", sport= 22");
    {
	SSH2_CHANNEL *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_tcpip"))
;
	SSH2_CHARP    host = SvPVbyte_nolen(ST(1))
;
	int	port = (int)SvIV(ST(2))
;
	SSH2_CHARP	shost;
	int	sport;

	if (items < 4)
	    shost = "127.0.0.1";
	else {
    shost = SvPVbyte_nolen(ST(3))
;
	}

	if (items < 5)
	    sport = 22;
	else {
	    sport = (int)SvIV(ST(4))
;
	}
#line 1494 "SSH2.xs"
    NEW_CHANNEL(libssh2_channel_direct_tcpip_ex(ss->session,
                                                (char*)host, port,
                                                (char*)shost, sport));
#line 2725 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::Channel", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_listen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_listen)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "ss, port, host= NULL, bound_port= NULL, queue_maxsize= 16");
    {
#line 1504 "SSH2.xs"
    int i_bound_port;
#line 2746 "SSH2.c"
	SSH2_LISTENER *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_listen"))
;
	int	port = (int)SvIV(ST(1))
;
	const char*	host;
	SV*	bound_port;
	int	queue_maxsize;

	if (items < 3)
	    host = NULL;
	else {
    host = (const char *)SvPV_nolen(ST(2))
;
	}

	if (items < 4)
	    bound_port = NULL;
	else {
	    bound_port = ST(3)
;
	}

	if (items < 5)
	    queue_maxsize = 16;
	else {
	    queue_maxsize = (int)SvIV(ST(4))
;
	}
#line 1506 "SSH2.xs"
    if (bound_port && SvOK(bound_port)) {
        if (!SvROK(bound_port) && SvTYPE(SvRV(bound_port)) <= SVt_PVNV)
            croak("%s::listen: bound port must be scalar reference", class);
    } else
        bound_port = NULL;
    NEW_LISTENER(libssh2_channel_forward_listen_ex(ss->session,
     (char*)host, port, bound_port ? &i_bound_port : NULL, queue_maxsize));
    if (RETVAL && bound_port)
        sv_setiv(SvRV(bound_port), i_bound_port);
#line 2786 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Net::SSH2::Listener", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAP 1


XS_EUPXS(XS_Net__SSH2_known_hosts); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_known_hosts)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2_KNOWNHOSTS *	RETVAL;
	SSH2 *    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_known_hosts"))
;
#line 1523 "SSH2.xs"
    NEW_KNOWNHOSTS(libssh2_knownhost_init(ss->session));
#line 2813 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Net::SSH2::KnownHosts", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAQ 1


XS_EUPXS(XS_Net__SSH2_known_hosts); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_known_hosts)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2 *    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_known_hosts"))
;
#line 1532 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for known_hosts support");
#line 2839 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__poll)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ss, timeout, event");
    {
#line 1539 "SSH2.xs"
    LIBSSH2_POLLFD* pollfd;
    int i, count, changed;
#line 2856 "SSH2.c"
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss__poll"))
;
	int	timeout = (int)SvIV(ST(1))
;
	AV*	event;

    if(SvROK(ST(2)) && SvTYPE(SvRV(ST(2))) == SVt_PVAV)
        event = (AV*)SvRV(ST(2));
    else
        croak("event is not an array reference")
;
#line 1542 "SSH2.xs"
    count = av_len(event) + 1;
    debug("%s::poll: timeout = %d, array[%d]\n", class, timeout, count);
    if (!count)  /* some architectures return null for malloc(0) */
        XSRETURN_IV(0);

    New(0, pollfd, count, LIBSSH2_POLLFD);
    if (!pollfd)
        Perl_croak(aTHX_ "Out of memory!");

    for (i = 0; i < count; ++i) {
        SV* sv = *av_fetch(event, i, 0/*lval*/), ** handle, ** events;
        HV* hv;

        if (!SvROK(sv) || SvTYPE(SvRV(sv)) != SVt_PVHV)
            croak("%s::poll: array element %d is not hash", class, i);
        hv = (HV*)SvRV(sv);

        if (!(handle = hv_fetch(hv, "handle", 6, 0/*lval*/)) || !*handle)
            croak("%s::poll: array element %d missing handle", class, i);
        if (sv_isobject(*handle)) {
            const char* package = HvNAME(SvSTASH(SvRV(*handle)));
            if (strEQ(package, "Net::SSH2::Channel")) {
                debug("- [%d] = channel\n", i);
                pollfd[i].type = LIBSSH2_POLLFD_CHANNEL;
                pollfd[i].fd.channel =
                 ((SSH2_CHANNEL*)SvIVX(GvSV((GV*)SvRV(*handle))))->channel;
            } else if(strEQ(package, "Net::SSH2::Listener")) {
                debug("- [%d] = listener\n", i);
                pollfd[i].type = LIBSSH2_POLLFD_LISTENER;
                pollfd[i].fd.listener =
                 ((SSH2_LISTENER*)SvIVX(SvRV(*handle)))->listener;
            } else {
                croak("%s::poll: invalid handle object in array (%d): %s",
                 class, i, package);
            }
        } else if(SvIOK(*handle)) {
            pollfd[i].type = LIBSSH2_POLLFD_SOCKET;
            pollfd[i].fd.socket = SvIV(*handle);
            debug("- [%d] = file(%d)\n", i, pollfd[i].fd.socket);
        } else {
            croak("%s::poll: invalid handle in array (%d): %s",
             class, i, SvPVbyte_nolen(*handle));
        }

        events = hv_fetch(hv, "events", 6, 0/*lval*/);
        if (!events || !*events || !SvIOK(*events)) {
            croak("%s::poll: bad or missing event mask in array (%d)",
             class, i);
        }
        pollfd[i].events = SvIV(*events);
        pollfd[i].revents = 0;
        debug("- [%d] events %d\n", i, pollfd[i].events);
    }

    changed = libssh2_poll(pollfd, count, timeout);
    debug("- libssh2_poll returned %d\n", changed);

    if (changed < 0)
        count = 0;
    for (i = 0; i < count; ++i) {
        HV* hv = (HV*)SvRV(*av_fetch(event, i, 0/*lval*/));
        hv_store(hv, "revents", 7, newSViv(pollfd[i].revents), 0/*hash*/);
        debug("- [%d] revents %d\n", i, pollfd[i].revents);
    }

    Safefree(pollfd);
    if (changed < 0)
        XSRETURN_EMPTY;
    XSRETURN_IV(changed);
#line 2938 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2_sftp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_sftp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2_SFTP *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_sftp"))
;
#line 1615 "SSH2.xs"
    NEW_SFTP(libssh2_sftp_init(ss->session));
#line 2956 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Net::SSH2::SFTP", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2_public_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2_public_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ss");
    {
	SSH2_PUBLICKEY *	RETVAL;
	SSH2*    ss = INT2PTR(SSH2 *, unwrap(ST(0), "Net::SSH2", "net_ss_public_key"))
;
#line 1622 "SSH2.xs"
    NEW_PUBLICKEY(libssh2_publickey_init(ss->session));
#line 2980 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Net::SSH2::PublicKey", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::Channel"

XS_EUPXS(XS_Net__SSH2__Channel_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_DESTROY"))
;
#line 1637 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    libssh2_channel_free(ch->channel);
    SvREFCNT_dec(ch->sv_ss);
    Safefree(ch);
#line 3008 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_session); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_session)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SV *	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_session"))
;
#line 1645 "SSH2.xs"
    RETVAL = newRV_inc(ch->sv_ss);
#line 3026 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel__setenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel__setenv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ch, key, value");
    {
#line 1652 "SSH2.xs"
    int i, success = 0;
    const char* pv_key, * pv_value;
    STRLEN len_key, len_value;
#line 3045 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch__setenv"))
;
	SV *	key = ST(1)
;
	SV *	value = ST(2)
;
#line 1656 "SSH2.xs"
    pv_key = SvPVbyte(key, len_key);
    pv_value = SvPVbyte(value, len_value);
    RETVAL = libssh2_channel_setenv_ex(ch->channel,
                                       (char*)pv_key, len_key,
                                       (char*)pv_value, len_value);
    save_eagain(ch->ss->session, RETVAL);
#line 3060 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010208
#define XSubPPtmpAAAR 1


XS_EUPXS(XS_Net__SSH2__Channel__exit_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel__exit_signal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1670 "SSH2.xs"
    char *exitsignal;
    char *errmsg;
    char *langtag;
    size_t exitsignal_len;
    size_t errmsg_len;
    size_t langtag_len;
    int retcount = 1;
#line 3092 "SSH2.c"
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch__exit_signal"))
;
#line 1678 "SSH2.xs"
    if (!libssh2_channel_get_exit_signal(ch->channel,
                                         &exitsignal, &exitsignal_len,
                                         &errmsg, &errmsg_len,
                                         &langtag, &langtag_len)) {
        LIBSSH2_SESSION *session = ch->ss->session;
        libssh2_session_set_last_error(session, 0, NULL);
        if (exitsignal) {
            XPUSHs(sv_2mortal(newSVpvn(exitsignal, exitsignal_len)));
            if (GIMME_V == G_ARRAY) {
                XPUSHs(errmsg ? sv_2mortal(newSVpvn(errmsg, errmsg_len)) : &PL_sv_undef);
                XPUSHs(langtag ? sv_2mortal(newSVpvn(langtag, langtag_len)) : &PL_sv_undef);
                retcount = 3;
            }
            libssh2_free(session, exitsignal);
            if (errmsg) libssh2_free(session, errmsg);
            if (langtag) libssh2_free(session, langtag);
        }
        else
            XPUSHs(&PL_sv_no);
        XSRETURN(retcount);
    }
    else
        XSRETURN(0);
#line 3119 "SSH2.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAS 1


XS_EUPXS(XS_Net__SSH2__Channel__exit_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel__exit_signal)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch__exit_signal"))
;
#line 1707 "SSH2.xs"
    croak("libssh2 version 1.2.8 or higher required for exit_signal support");
#line 3140 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__Channel_eof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_eof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_BYTES	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_eof"))
;
#line 1714 "SSH2.xs"
    RETVAL = libssh2_channel_eof(ch->channel);
    save_eagain(ch->ss->session, RETVAL);
#line 3160 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_send_eof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_send_eof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_send_eof"))
;
#line 1722 "SSH2.xs"
    RETVAL = libssh2_channel_send_eof(ch->channel);
    save_eagain(ch->ss->session, RETVAL);
#line 3185 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_close"))
;
#line 1730 "SSH2.xs"
    RETVAL = libssh2_channel_close(ch->channel);
    save_eagain(ch->ss->session, RETVAL);
#line 3210 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel__wait_closed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel__wait_closed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch__wait_closed"))
;
#line 1738 "SSH2.xs"
    RETVAL = libssh2_channel_wait_closed(ch->channel);
    save_eagain(ch->ss->session, RETVAL);
#line 3235 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_wait_eof); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_wait_eof)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_wait_eof"))
;
#line 1746 "SSH2.xs"
    RETVAL = libssh2_channel_wait_eof(ch->channel);
    save_eagain(ch->ss->session, RETVAL);
#line 3260 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel__exit_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel__exit_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	int	RETVAL;
	dXSTARG;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch__exit_status"))
;
#line 1754 "SSH2.xs"
    RETVAL = libssh2_channel_get_exit_status(ch->channel);
#line 3285 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_MAJOR >= 1
#define XSubPPtmpAAAT 1


XS_EUPXS(XS_Net__SSH2__Channel__pty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel__pty)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "ch, terminal, modes= NULL, width= 0, height= 0");
    {
#line 1764 "SSH2.xs"
    const char* pv_terminal, * pv_modes = NULL;
    STRLEN len_terminal, len_modes = 0;
    int width_px = LIBSSH2_TERM_WIDTH_PX, height_px = LIBSSH2_TERM_HEIGHT_PX;
#line 3306 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch__pty"))
;
	SV*	terminal = ST(1)
;
	SV*	modes;
	int	width;
	int	height;

	if (items < 3)
	    modes = NULL;
	else {
	    modes = ST(2)
;
	}

	if (items < 4)
	    width = 0;
	else {
	    width = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    height = 0;
	else {
	    height = (int)SvIV(ST(4))
;
	}
#line 1768 "SSH2.xs"
    pv_terminal = SvPVbyte(terminal, len_terminal);
    if (modes && SvPOK(modes))
        pv_modes = SvPVbyte(modes, len_modes);
    if (!width)
        width = LIBSSH2_TERM_WIDTH;
    else if(width < 0) {
        width_px = -width;
        width = 0;
    }
    if (!height)
        height = LIBSSH2_TERM_HEIGHT;
    else if(height < 0) {
        height_px = -height;
        height = 0;
    }
    RETVAL = libssh2_channel_request_pty_ex(ch->channel,
                                            (char*)pv_terminal, len_terminal,
                                            (char*)pv_modes, len_modes,
                                            width, height, width_px, height_px);
    save_eagain(ch->ss->session, RETVAL);
#line 3357 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_pty_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_pty_size)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "ch, width= 0, height= 0");
    {
#line 1794 "SSH2.xs"
    int width_px = LIBSSH2_TERM_WIDTH_PX, height_px = LIBSSH2_TERM_HEIGHT_PX;
#line 3378 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_pty_size"))
;
	int	width;
	int	height;

	if (items < 2)
	    width = 0;
	else {
	    width = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    height = 0;
	else {
	    height = (int)SvIV(ST(2))
;
	}
#line 1796 "SSH2.xs"
    if (!width)
        croak("%s::pty_size: required parameter width missing", class);
    else if(width < 0) {
        width_px = -width;
        width = 0;
    }

    if (!height)
        croak("%s::pty_size: required parameter height missing", class);
    else if(height < 0) {
        height_px = -height;
        height = 0;
    }

    RETVAL = libssh2_channel_request_pty_size_ex(ch->channel,
                                                 width, height, width_px, height_px);
    save_eagain(ch->ss->session, RETVAL);
#line 3416 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAU 1


XS_EUPXS(XS_Net__SSH2__Channel_pty); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_pty)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 5)
       croak_xs_usage(cv,  "ch, terminal, modes= NULL, width= 0, height= 0");
    {
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_pty"))
;
	SV*	terminal = ST(1)
;
	SV*	modes;
	int	width;
	int	height;

	if (items < 3)
	    modes = NULL;
	else {
	    modes = ST(2)
;
	}

	if (items < 4)
	    width = 0;
	else {
	    width = (int)SvIV(ST(3))
;
	}

	if (items < 5)
	    height = 0;
	else {
	    height = (int)SvIV(ST(4))
;
	}
#line 1822 "SSH2.xs"
    croak("libssh2 version 1.0 or higher required for PTY support");
#line 3468 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_pty_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_pty_size)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "ch, width= 0, height= 0");
    {
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_pty_size"))
;
	int	width;
	int	height;

	if (items < 2)
	    width = 0;
	else {
	    width = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    height = 0;
	else {
	    height = (int)SvIV(ST(2))
;
	}
#line 1827 "SSH2.xs"
    croak("libssh2 version 1.0 or higher required for PTY support");
#line 3501 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__Channel_process); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_process)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ch, request, message= NULL");
    {
#line 1834 "SSH2.xs"
    const char* pv_request, * pv_message = NULL;
    STRLEN len_request, len_message = 0;
#line 3518 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_process"))
;
	SV*	request = ST(1)
;
	SV*	message;

	if (items < 3)
	    message = NULL;
	else {
	    message = ST(2)
;
	}
#line 1837 "SSH2.xs"
    pv_request = SvPVbyte(request, len_request);
    if (message && SvPOK(message))
        pv_message = SvPVbyte(message, len_message);
    RETVAL = libssh2_channel_process_startup(ch->channel,
                                             pv_request, len_request,
                                             pv_message, len_message);
    save_eagain(ch->ss->session, RETVAL);
#line 3540 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_ext_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_ext_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ch, mode");
    {
	int	RETVAL;
	dXSTARG;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_ext_data"))
;
	SSH2_CHANNEL_EXTENDED_DATA    mode = sv2iv_constant_or_croak("CHANNEL_EXTENDED_DATA", ST(1))
;
#line 1850 "SSH2.xs"
    libssh2_channel_handle_extended_data(ch->channel, (int)mode);
    RETVAL = 1;
#line 3568 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_read)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "ch, buffer, size= 32768, ext= 0");
    {
#line 1858 "SSH2.xs"
    char* pv_buffer;
    STRLEN len_buffer;
    int blocking, count = 0;
    size_t total = 0;
#line 3587 "SSH2.c"
	SSH2_BYTES64	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_read"))
;
	SV*	buffer = ST(1)
;
	size_t	size;
	SSH2_STREAM_ID	ext;

	if (items < 3)
	    size = 32768;
	else {
    size = SV2TYPE(ST(2), size_t)
;
	}

	if (items < 4)
	    ext = 0;
	else {
    ext = sv2iv_constant_or_croak("CHANNEL_FLUSH", ST(3))
;
	}
#line 1863 "SSH2.xs"
    debug("%s::read(size = %d, ext = %d)\n", class, size, ext);
    sv_force_normal(buffer);
    sv_setpvn_mg(buffer, "", 0);
    SvPVbyte_force(buffer, len_buffer);
    pv_buffer = sv_grow(buffer, size + 1);
    blocking = libssh2_session_get_blocking(ch->ss->session);
    while (size) {
        count = libssh2_channel_read_ex(ch->channel, ext, pv_buffer, size);
        debug("- read %d bytes\n", count);
        if (count > 0) {
            total += count;
            pv_buffer += count;
            size -= count;
            if (blocking) break;
        }
        else {
            if ((count != LIBSSH2_ERROR_EAGAIN) || !blocking) break;
        }
    }
    debug("- read %d total\n", total);
    if (total || (count == 0)) {
        pv_buffer[0] = '\0';
        SvPOK_only(buffer);
        SvCUR_set(buffer, total);
        SvSETMAGIC(buffer);
        RETVAL = total;
    }
    else {
        SvOK_off(buffer);
        SvSETMAGIC(buffer);
        save_eagain(ch->ss->session, count);
        RETVAL = count;
    }
#line 3643 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : ((IVSIZE >= 8) ? newSVuv(RETVAL) : newSVnv(RETVAL)) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_getc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_getc)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ch, ext= 0");
    {
#line 1902 "SSH2.xs"
    char buffer[2];
    int count;
#line 3665 "SSH2.c"
	SV *	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_getc"))
;
	SSH2_STREAM_ID	ext;

	if (items < 2)
	    ext = 0;
	else {
    ext = sv2iv_constant_or_croak("CHANNEL_FLUSH", ST(1))
;
	}
#line 1905 "SSH2.xs"
    debug("%s::getc(ext = %d)\n", class, ext);
    count = libssh2_channel_read_ex(ch->channel, ext, buffer, 1);
    if (count >= 0) {
        buffer[count] = '\0';
        RETVAL = newSVpvn(buffer, count);
    }
    else {
        save_eagain(ch->ss->session, count);
        RETVAL = &PL_sv_undef;
    }
#line 3688 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__Channel_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_write)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ch, buffer, ext= 0");
    {
#line 1921 "SSH2.xs"
    const char* pv_buffer;
    STRLEN len_buffer, offset = 0;
    int count = 0;
#line 3707 "SSH2.c"
	SSH2_BYTES	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_write"))
;
	SV*	buffer = ST(1)
;
	SSH2_STREAM_ID	ext;

	if (items < 3)
	    ext = 0;
	else {
    ext = sv2iv_constant_or_croak("CHANNEL_FLUSH", ST(2))
;
	}
#line 1925 "SSH2.xs"
    /*
       1. in blocking mode, write all the data.
       2. in non-blocking mode, write as much data as possible without
          blocking.
       3. if some error happens...
          a. if some data was already written, discard the error and
             report the number of bytes written.
          b. if no data was written, report the error.
    */
    pv_buffer = SvPVbyte(buffer, len_buffer);
    while (offset < len_buffer) {
        count = libssh2_channel_write_ex(ch->channel, ext,
                                         pv_buffer + offset,
                                         len_buffer - offset);
        if (count >= 0)
            offset += count;
        else if ((count != LIBSSH2_ERROR_EAGAIN) ||
                 !libssh2_session_get_blocking(ch->ss->session))
            break;
    }
    if (offset || (count == 0)) /* yes, zero is a valid value */
        RETVAL = offset;
    else {
        save_eagain(ch->ss->session, count);
        RETVAL = -1;
    }
#line 3748 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if LIBSSH2_VERSION_NUM >= 0x010100
#define XSubPPtmpAAAV 1


XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "ch, adjustment, force= &PL_sv_undef");
    {
#line 1959 "SSH2.xs"
    unsigned int bytes;
#line 3772 "SSH2.c"
	SSH2_BYTES	RETVAL;
	SSH2_CHANNEL *    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_receive_window_adjust"))
;
	unsigned long	adjustment = (unsigned long)SvUV(ST(1))
;
	SV *	force;

	if (items < 3)
	    force = &PL_sv_undef;
	else {
	    force = ST(2)
;
	}
#line 1961 "SSH2.xs"
    RETVAL = libssh2_channel_receive_window_adjust2(ch->channel, adjustment,
                                                    SvTRUE(force), &bytes);
    if (RETVAL)
        save_eagain(ch->ss->session, RETVAL);
    else
        RETVAL = bytes;
#line 3793 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAW 1


XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_receive_window_adjust)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "ch, ...");
    {
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_receive_window_adjust"))
;
#line 1975 "SSH2.xs"
    croak("libssh2 version 1.1 or higher required for receive_window_adjust support");
#line 3819 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif
#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAX 1


XS_EUPXS(XS_Net__SSH2__Channel_window_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1984 "SSH2.xs"
    unsigned long window_size_initial = 0;
#line 3840 "SSH2.c"
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_window_write"))
;
#line 1986 "SSH2.xs"
    XPUSHs(sv_2mortal(newSVuv(libssh2_channel_window_write_ex(ch->channel,
                                                              &window_size_initial))));
    if (GIMME_V == G_ARRAY) {
        XPUSHs(sv_2mortal(newSVuv(window_size_initial)));
        XSRETURN(2);
    }
    else
        XSRETURN(1);
#line 3852 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__Channel_window_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1998 "SSH2.xs"
    unsigned long read_avail = 0;
    unsigned long window_size_initial = 0;
#line 3871 "SSH2.c"
	SSH2_CHANNEL *    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_window_read"))
;
#line 2001 "SSH2.xs"
    XPUSHs(sv_2mortal(newSVuv(libssh2_channel_window_read_ex(ch->channel,
                                                             &read_avail,
                                                             &window_size_initial))));
    if (GIMME_V == G_ARRAY) {
        XPUSHs(sv_2mortal(newSVuv(read_avail)));
        XPUSHs(sv_2mortal(newSVuv(window_size_initial)));
        XSRETURN(3);
    }
    else
        XSRETURN(1);
#line 3885 "SSH2.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAY 1


XS_EUPXS(XS_Net__SSH2__Channel_window_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_write)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_window_write"))
;
#line 2017 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for window_write support");
#line 3906 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Channel_window_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_window_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ch");
    {
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_window_read"))
;
#line 2022 "SSH2.xs"
    croak("libssh2 version 1.2 or higher required for window_read support");
#line 3923 "SSH2.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Net__SSH2__Channel_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Channel_flush)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "ch, ext= 0");
    {
	SSH2_BYTES	RETVAL;
	SSH2_CHANNEL*    ch = INT2PTR(SSH2_CHANNEL *, unwrap_tied(ST(0), "Net::SSH2::Channel", "net_ch_flush"))
;
	SSH2_STREAM_ID	ext;

	if (items < 2)
	    ext = 0;
	else {
    ext = sv2iv_constant_or_croak("CHANNEL_FLUSH", ST(1))
;
	}
#line 2029 "SSH2.xs"
    RETVAL = libssh2_channel_flush_ex(ch->channel, ext);
    save_eagain(ch->ss->session, RETVAL);
#line 3951 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::Listener"

XS_EUPXS(XS_Net__SSH2__Listener_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Listener_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ls");
    {
	SSH2_LISTENER*    ls = INT2PTR(SSH2_LISTENER *, unwrap(ST(0), "Net::SSH2::Listener", "net_ls_DESTROY"))
;
#line 2045 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    libssh2_channel_forward_cancel(ls->listener);
    SvREFCNT_dec(ls->sv_ss);
    Safefree(ls);
#line 3979 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Listener_accept); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Listener_accept)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ls");
    {
#line 2053 "SSH2.xs"
    SSH2* ss;
#line 3994 "SSH2.c"
	SSH2_CHANNEL *	RETVAL;
	SSH2_LISTENER*    ls = INT2PTR(SSH2_LISTENER *, unwrap(ST(0), "Net::SSH2::Listener", "net_ls_accept"))
;
#line 2055 "SSH2.xs"
    ss = ls->ss;
    NEW_CHANNEL(libssh2_channel_forward_accept(ls->listener));
#line 4001 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::Channel", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::SFTP"

XS_EUPXS(XS_Net__SSH2__SFTP_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sf");
    {
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_DESTROY"))
;
#line 2071 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    libssh2_sftp_shutdown(sf->sftp);
    debug("%s::DESTROY freeing session\n", class);
    SvREFCNT_dec(sf->sv_ss);
    Safefree(sf);
#line 4030 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__SFTP_session); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_session)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sf");
    {
	SV *	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_session"))
;
#line 2080 "SSH2.xs"
    RETVAL = newRV_inc(sf->sv_ss);
#line 4048 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_error)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sf");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2087 "SSH2.xs"
    unsigned long error;
    SV *errstr;
#line 4068 "SSH2.c"
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_error"))
;
#line 2090 "SSH2.xs"
    error = libssh2_sftp_last_error(sf->sftp);
    ST(0) = sv_2mortal(newSVuv(error));
    if (GIMME_V == G_ARRAY) {
        EXTEND(SP, 2);
        if ((error >= 0) && (error < countof(sftp_error)))
            errstr = newSVpvf("SSH_FX_%s", sftp_error[error]);
        else
            errstr = newSVpvf("SSH_FX_UNKNOWN(%lu)", error);
        ST(1) = sv_2mortal(errstr);
        XSRETURN(2);
    }
    else
        XSRETURN(1);
#line 4085 "SSH2.c"
	PUTBACK;
	return;
    }
}

#define XLATFLAG(posix, fxf) do { \
    if (flags & posix || \
     l_flags == 0 && posix == 0 && flags == posix /* 0-valued flag */) { \
        l_flags |= fxf; \
        flags &= ~posix; \
    } \
} while(0)

XS_EUPXS(XS_Net__SSH2__SFTP_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_open)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "sf, file, flags= O_RDONLY, mode= 0666");
    {
#line 2115 "SSH2.xs"
    long l_flags = 0;
    const char* pv_file;
    STRLEN len_file;
#line 4110 "SSH2.c"
	SSH2_FILE *	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_open"))
;
	SV*	file = ST(1)
;
	int	flags;
	int	mode;

	if (items < 3)
	    flags = O_RDONLY;
	else {
	    flags = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    mode = 0666;
	else {
	    mode = (int)SvIV(ST(3))
;
	}
#line 2119 "SSH2.xs"
    pv_file = SvPVbyte(file, len_file);

    /* map POSIX O_* to LIBSSH2_FXF_* (can't assume they're the same) */
    XLATFLAG(O_RDWR,   LIBSSH2_FXF_READ | LIBSSH2_FXF_WRITE);
    XLATFLAG(O_RDONLY, LIBSSH2_FXF_READ);
    XLATFLAG(O_WRONLY, LIBSSH2_FXF_WRITE);
    XLATFLAG(O_APPEND, LIBSSH2_FXF_APPEND);
    XLATFLAG(O_CREAT,  LIBSSH2_FXF_CREAT);
    XLATFLAG(O_TRUNC,  LIBSSH2_FXF_TRUNC);
    XLATFLAG(O_EXCL,   LIBSSH2_FXF_EXCL);
    if (flags)
        croak("%s::open: unknown flag value: %d", class, flags);

    NEW_FILE(libssh2_sftp_open_ex(sf->sftp, (char*)pv_file, len_file,
     l_flags, mode, LIBSSH2_SFTP_OPENFILE));
#line 4148 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    wrap_tied_into(RETVALSV, "Net::SSH2::File", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#undef XLATFLAG

XS_EUPXS(XS_Net__SSH2__SFTP_opendir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_opendir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, dir");
    {
#line 2142 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 4171 "SSH2.c"
	SSH2_DIR *	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_opendir"))
;
	SV*	dir = ST(1)
;
#line 2145 "SSH2.xs"
    pv_dir = SvPVbyte(dir, len_dir);
    NEW_DIR(libssh2_sftp_open_ex(sf->sftp, (char*)pv_dir, len_dir,
     0/*flags*/, 0/*mode*/, LIBSSH2_SFTP_OPENDIR));
#line 4181 "SSH2.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
    sv_setref_pv(RETVALSV, "Net::SSH2::Dir", (void *)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_unlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_unlink)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, file");
    {
#line 2154 "SSH2.xs"
    char* pv_file;
    STRLEN len_file;
#line 4203 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_unlink"))
;
	SV*	file = ST(1)
;
#line 2157 "SSH2.xs"
    pv_file = SvPVbyte(file, len_file);
    RETVAL = libssh2_sftp_unlink_ex(sf->sftp, (char*)pv_file, len_file);
#line 4212 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_rename)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "sf, old, new, flags= ( LIBSSH2_SFTP_RENAME_OVERWRITE |     LIBSSH2_SFTP_RENAME_ATOMIC    |     LIBSSH2_SFTP_RENAME_NATIVE )");
    {
#line 2168 "SSH2.xs"
    const char* pv_old, * pv_new;
    STRLEN len_old, len_new;
#line 4234 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_rename"))
;
	SV*	old = ST(1)
;
	SV*	new = ST(2)
;
	long	flags;

	if (items < 4)
	    flags = ( LIBSSH2_SFTP_RENAME_OVERWRITE |     LIBSSH2_SFTP_RENAME_ATOMIC    |     LIBSSH2_SFTP_RENAME_NATIVE );
	else {
    flags = SV2TYPE(ST(3), long)
;
	}
#line 2171 "SSH2.xs"
    pv_old = SvPVbyte(old, len_old);
    pv_new = SvPVbyte(new, len_new);
    RETVAL = libssh2_sftp_rename_ex(sf->sftp,
                                    (char*)pv_old, len_old, (char*)pv_new, len_new, flags);
#line 4255 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_mkdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_mkdir)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sf, dir, mode= 0777");
    {
#line 2181 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 4277 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_mkdir"))
;
	SV*	dir = ST(1)
;
	int	mode;

	if (items < 3)
	    mode = 0777;
	else {
	    mode = (int)SvIV(ST(2))
;
	}
#line 2184 "SSH2.xs"
    pv_dir = SvPVbyte(dir, len_dir);
    RETVAL = libssh2_sftp_mkdir_ex(sf->sftp, (char*)pv_dir, len_dir, mode);
#line 4294 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_rmdir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_rmdir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, dir");
    {
#line 2192 "SSH2.xs"
    const char* pv_dir;
    STRLEN len_dir;
#line 4316 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_rmdir"))
;
	SV*	dir = ST(1)
;
#line 2195 "SSH2.xs"
    pv_dir = SvPVbyte(dir, len_dir);
    RETVAL = libssh2_sftp_rmdir_ex(sf->sftp, (char*)pv_dir, len_dir);
#line 4325 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_stat)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sf, path, follow= 1");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2203 "SSH2.xs"
    const char* pv_path;
    STRLEN len_path;
    int error;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 4351 "SSH2.c"
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_stat"))
;
	SV*	path = ST(1)
;
	int	follow;

	if (items < 3)
	    follow = 1;
	else {
	    follow = (int)SvIV(ST(2))
;
	}
#line 2208 "SSH2.xs"
    pv_path = SvPVbyte(path, len_path);
    error = libssh2_sftp_stat_ex(sf->sftp, (char*)pv_path, len_path,
                                  (follow ? LIBSSH2_SFTP_STAT : LIBSSH2_SFTP_LSTAT),
                                  &attrs);
    if (error < 0)
        XSRETURN_EMPTY;
    XSRETURN_STAT_ATTRS(SvREFCNT_inc(path));
#line 4372 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__SFTP_setstat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_setstat)
{
    dVAR; dXSARGS;
    if (items < 2)
       croak_xs_usage(cv,  "sf, path, ...");
    {
#line 2219 "SSH2.xs"
    const char* pv_path;
    STRLEN len_path;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
    int i;
#line 4391 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_setstat"))
;
	SV*	path = ST(1)
;
#line 2224 "SSH2.xs"
    pv_path = SvPVbyte(path, len_path);
    Zero(&attrs, 1, LIBSSH2_SFTP_ATTRIBUTES);

    /* read key/value pairs; cf. hv_from_attrs */
    for (i = 2; i < items; i += 2) {
        const char* key = SvPVbyte_nolen(ST(i));
        if (i + 1 == items)
            croak("%s::setstat: key without value", class);
        if (0);  /* prime the chain */
        XLATATTR("size",  filesize,    SIZE)
        XLATATTR("uid",   uid,         UIDGID)
        XLATATTR("gid",   gid,         UIDGID)
        XLATATTR("mode",  permissions, PERMISSIONS)
        XLATATTR("atime", atime,       ACMODTIME)
        XLATATTR("mtime", mtime,       ACMODTIME)
        else
            croak("%s::setstat: unknown attribute: %s", class, key);
    }
    RETVAL = libssh2_sftp_stat_ex(sf->sftp, (char*)pv_path, len_path,
                                  LIBSSH2_SFTP_SETSTAT, &attrs);
#line 4418 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_symlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_symlink)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sf, path, target");
    {
#line 2250 "SSH2.xs"
    char *pv_path, *pv_target;
    STRLEN len_path, len_target;
#line 4440 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_symlink"))
;
	SV*	path = ST(1)
;
	SV*	target = ST(2)
;
#line 2253 "SSH2.xs"
    pv_path = SvPVbyte(path, len_path);
    pv_target = SvPVbyte(target, len_target);
    RETVAL = libssh2_sftp_symlink_ex(sf->sftp,
                                     pv_path, len_path,
                                     pv_target, len_target,
                                     LIBSSH2_SFTP_SYMLINK);
#line 4455 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_readlink); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_readlink)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, path");
    {
#line 2265 "SSH2.xs"
    const char* pv_path;
    char* pv_link;
    STRLEN len_path;
    int count;
#line 4479 "SSH2.c"
	SV *	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_readlink"))
;
	SV*	path = ST(1)
;
#line 2270 "SSH2.xs"
    pv_path = SvPVbyte(path, len_path);
    RETVAL = newSV(MAXPATHLEN + 1);
    pv_link = SvPVX(RETVAL);
    count = libssh2_sftp_symlink_ex(sf->sftp,
                                    pv_path, len_path,
                                    pv_link, MAXPATHLEN,
                                    LIBSSH2_SFTP_READLINK);
    if (count >= 0) {
        SvPOK_on(RETVAL);
        pv_link[count] = '\0';
        SvCUR_set(RETVAL, count);
    }
#line 4498 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__SFTP_realpath); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__SFTP_realpath)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sf, path");
    {
#line 2288 "SSH2.xs"
    const char* pv_path;
    char* pv_real;
    STRLEN len_path;
    int count;
#line 4518 "SSH2.c"
	SV *	RETVAL;
	SSH2_SFTP*    sf = INT2PTR(SSH2_SFTP *, unwrap(ST(0), "Net::SSH2::SFTP", "net_sf_realpath"))
;
	SV*	path = ST(1)
;
#line 2293 "SSH2.xs"
    pv_path = SvPVbyte(path, len_path);
    RETVAL = newSV(MAXPATHLEN + 1);
    pv_real = SvPVX(RETVAL);
    count = libssh2_sftp_symlink_ex(sf->sftp,
                                    pv_path, len_path,
                                    pv_real, MAXPATHLEN,
                                    LIBSSH2_SFTP_REALPATH);
    if (count >= 0) {
        SvPOK_on(RETVAL);
        pv_real[count] = '\0';
        SvCUR_set(RETVAL, count);
    }
#line 4537 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::File"

XS_EUPXS(XS_Net__SSH2__File_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fi");
    {
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_DESTROY"))
;
#line 2319 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    libssh2_sftp_close_handle(fi->handle);
    SvREFCNT_dec(fi->sv_sf);
    Safefree(fi);
#line 4561 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__File_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_read)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fi, buffer, size");
    {
#line 2327 "SSH2.xs"
    char* pv_buffer;
    STRLEN len_buffer;
#line 4577 "SSH2.c"
	SSH2_BYTES	RETVAL;
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_read"))
;
	SV*	buffer = ST(1)
;
	size_t    size = SV2TYPE(ST(2), size_t)
;
#line 2330 "SSH2.xs"
    sv_force_normal(buffer);
    sv_setpvn_mg(buffer, "", 0);
    SvPVbyte_force(buffer, len_buffer);
    pv_buffer = sv_grow(buffer, size + 1);
    RETVAL = libssh2_sftp_read(fi->handle, pv_buffer, size);
    if (RETVAL < 0)
        SvOK_off(buffer);
    else {
        SvPOK_only(buffer);
        pv_buffer[RETVAL] = '\0';
        SvCUR_set(buffer, RETVAL);
    }
    SvSETMAGIC(buffer);
#line 4599 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__File_getc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_getc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fi");
    {
#line 2349 "SSH2.xs"
    char buffer[2];
    int count;
#line 4621 "SSH2.c"
	SV *	RETVAL;
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_getc"))
;
#line 2352 "SSH2.xs"
    count = libssh2_sftp_read(fi->handle, buffer, 1);
    if (count == 1) {
        buffer[count] = '\0';
        RETVAL = newSVpvn(buffer, count);
    }
    else
        RETVAL = &PL_sv_undef;
#line 4633 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__File_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_write)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fi, buffer");
    {
#line 2365 "SSH2.xs"
    const char* pv_buffer;
    STRLEN len_buffer;
#line 4651 "SSH2.c"
	SSH2_BYTES	RETVAL;
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_write"))
;
	SV*	buffer = ST(1)
;
#line 2368 "SSH2.xs"
    sv_utf8_downgrade(buffer, 0);
    pv_buffer = SvPVbyte(buffer, len_buffer);
    RETVAL = libssh2_sftp_write(fi->handle, pv_buffer, len_buffer);
#line 4661 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__File_stat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_stat)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fi");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2377 "SSH2.xs"
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 4684 "SSH2.c"
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_stat"))
;
#line 2379 "SSH2.xs"
    if (libssh2_sftp_fstat(fi->handle, &attrs))
        XSRETURN_EMPTY;
    XSRETURN_STAT_ATTRS(NULL/*name*/);
#line 4691 "SSH2.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Net__SSH2__File_setstat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_setstat)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "fi, ...");
    {
#line 2386 "SSH2.xs"
    LIBSSH2_SFTP_ATTRIBUTES attrs;
    int i;
#line 4708 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_setstat"))
;
#line 2389 "SSH2.xs"
    Zero(&attrs, 1, LIBSSH2_SFTP_ATTRIBUTES);

    /* read key/value pairs; cf. hv_from_attrs */
    for (i = 1; i < items; i += 2) {
        const char* key = SvPVbyte_nolen(ST(i));
        if (i + 1 == items)
            croak("%s::setstat: key without value", class);
        if (0);  /* prime the chain */
        XLATATTR("size",  filesize,    SIZE)
        XLATATTR("uid",   uid,         UIDGID)
        XLATATTR("gid",   gid,         UIDGID)
        XLATATTR("mode",  permissions, PERMISSIONS)
        XLATATTR("atime", atime,       ACMODTIME)
        XLATATTR("mtime", mtime,       ACMODTIME)
        else
            croak("%s::setstat: unknown attribute: %s", class, key);
    }
    RETVAL = libssh2_sftp_fsetstat(fi->handle, &attrs);
#line 4731 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__File_seek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_seek)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fi, offset");
    {
	int	RETVAL;
	dXSTARG;
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_seek"))
;
	size_t    offset = SV2TYPE(ST(1), size_t)
;
#line 2413 "SSH2.xs"
    libssh2_sftp_seek64(fi->handle, offset);
    RETVAL = 1;
#line 4759 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__File_tell); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__File_tell)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fi");
    {
	SSH2_BYTES64	RETVAL;
	SSH2_FILE*    fi = INT2PTR(SSH2_FILE *, unwrap_tied(ST(0), "Net::SSH2::File", "net_fi_tell"))
;
#line 2421 "SSH2.xs"
    RETVAL = libssh2_sftp_tell64(fi->handle);
#line 4778 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : ((IVSIZE >= 8) ? newSVuv(RETVAL) : newSVnv(RETVAL)) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#undef class
#define class "Net::SSH2::Dir"

XS_EUPXS(XS_Net__SSH2__Dir_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Dir_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "di");
    {
	SSH2_DIR*    di = INT2PTR(SSH2_DIR *, unwrap(ST(0), "Net::SSH2::Dir", "net_di_DESTROY"))
;
#line 2435 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    libssh2_sftp_close_handle(di->handle);
    SvREFCNT_dec(di->sv_sf);
    Safefree(di);
#line 4806 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__Dir_read); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__Dir_read)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "di");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2443 "SSH2.xs"
    SV* buffer;
    char* pv_buffer;
    int count;
    LIBSSH2_SFTP_ATTRIBUTES attrs;
#line 4826 "SSH2.c"
	SSH2_DIR*    di = INT2PTR(SSH2_DIR *, unwrap(ST(0), "Net::SSH2::Dir", "net_di_read"))
;
#line 2448 "SSH2.xs"
    buffer = newSV(MAXPATHLEN + 1);
    SvPOK_on(buffer);
    pv_buffer = SvPVX(buffer);

    count = libssh2_sftp_readdir(di->handle, pv_buffer, MAXPATHLEN, &attrs);

    if (count <= 0) {
        SvREFCNT_dec(buffer);
        XSRETURN_EMPTY;
    }
    pv_buffer[count] = '\0';
    SvCUR_set(buffer, count);
    XSRETURN_STAT_ATTRS(buffer);
#line 4843 "SSH2.c"
	PUTBACK;
	return;
    }
}

#undef class
#define class "Net::SSH2::PublicKey"

XS_EUPXS(XS_Net__SSH2__PublicKey_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pk");
    {
	SSH2_PUBLICKEY*    pk = INT2PTR(SSH2_PUBLICKEY *, unwrap(ST(0), "Net::SSH2::PublicKey", "net_pk_DESTROY"))
;
#line 2473 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    libssh2_publickey_shutdown(pk->pkey);
    SvREFCNT_dec(pk->sv_ss);
    Safefree(pk);
#line 4866 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__PublicKey_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_add)
{
    dVAR; dXSARGS;
    if (items < 4)
       croak_xs_usage(cv,  "pk, name, blob, overwrite, ...");
    {
#line 2481 "SSH2.xs"
    const char* pv_name, * pv_blob;
    STRLEN len_name, len_blob;
    unsigned long num_attrs, i;
    libssh2_publickey_attribute *attrs;
#line 4884 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_PUBLICKEY*    pk = INT2PTR(SSH2_PUBLICKEY *, unwrap(ST(0), "Net::SSH2::PublicKey", "net_pk_add"))
;
	SV*	name = ST(1)
;
	SV*	blob = ST(2)
;
	int	overwrite = (int)SvIV(ST(3))
;
#line 2486 "SSH2.xs"
    pv_name = SvPVbyte(name, len_name);
    pv_blob = SvPVbyte(blob, len_blob);

    num_attrs = items - 4;
    New(0, attrs, num_attrs, libssh2_publickey_attribute);
    if (!attrs)
        Perl_croak(aTHX_ "Out of memory!");

    for (i = 0; i < num_attrs; ++i) {
        HV* hv;
        SV** tmp;
        STRLEN len_tmp;

        if (!SvROK(ST(i + 4)) || SvTYPE(SvRV(ST(i + 4))) != SVt_PVHV)
            croak("%s::add: attribute %lu is not hash", class, i);
        hv = (HV*)SvRV(ST(i + 4));

        if (!(tmp = hv_fetch(hv, "name", 4, 0/*lval*/)) || !*tmp)
            croak("%s::add: attribute %lu missing name", class, i);
        attrs[i].name = SvPVbyte(*tmp, len_tmp);
        attrs[i].name_len = len_tmp;

        if ((tmp = hv_fetch(hv, "value", 5, 0/*lval*/)) && *tmp) {
            attrs[i].value = SvPVbyte(*tmp, len_tmp);
            attrs[i].value_len = len_tmp;
        } else
            attrs[i].value_len = 0;

        if ((tmp = hv_fetch(hv, "mandatory", 9, 0/*lval*/)) && *tmp)
            attrs[i].mandatory = (char)SvIV(*tmp);
        else
            attrs[i].mandatory = 0;
    }

    RETVAL = libssh2_publickey_add_ex(pk->pkey,
                                      (const unsigned char *)pv_name, len_name,
                                      (const unsigned char *)pv_blob, len_blob, overwrite, num_attrs, attrs);
    Safefree(attrs);
#line 4933 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__PublicKey_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_remove)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pk, name, blob");
    {
#line 2530 "SSH2.xs"
    const char* pv_name, * pv_blob;
    STRLEN len_name, len_blob;
#line 4955 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_PUBLICKEY*    pk = INT2PTR(SSH2_PUBLICKEY *, unwrap(ST(0), "Net::SSH2::PublicKey", "net_pk_remove"))
;
	SV*	name = ST(1)
;
	SV*	blob = ST(2)
;
#line 2533 "SSH2.xs"
    pv_name = SvPVbyte(name, len_name);
    pv_blob = SvPVbyte(blob, len_blob);
    RETVAL = libssh2_publickey_remove_ex(pk->pkey,
                                         (const unsigned char *)pv_name, len_name,
                                         (const unsigned char *)pv_blob, len_blob);
#line 4969 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__PublicKey_fetch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__PublicKey_fetch)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pk");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2544 "SSH2.xs"
    unsigned long keys, i, j;
    libssh2_publickey_list* list = NULL;
#line 4993 "SSH2.c"
	SSH2_PUBLICKEY*    pk = INT2PTR(SSH2_PUBLICKEY *, unwrap(ST(0), "Net::SSH2::PublicKey", "net_pk_fetch"))
;
#line 2547 "SSH2.xs"
    if (!libssh2_publickey_list_fetch(pk->pkey, &keys, &list) || !list)
        XSRETURN_EMPTY;

    if (GIMME_V == G_ARRAY) {
        EXTEND(SP, keys);

        for (i = 0; i < keys; ++i) {
            HV* hv = newHV();
            AV* av = newAV();

            hv_store(hv, "name", 4,
             newSVpvn((char*)list[i].name, list[i].name_len), 0/*hash*/);
            hv_store(hv, "blob", 4,
             newSVpvn((char*)list[i].blob, list[i].blob_len), 0/*hash*/);

            hv_store(hv, "attr", 4, newRV_noinc((SV*)av), 0/*hash*/);
            av_extend(av, list[i].num_attrs - 1);
            for (j = 0; j < list[i].num_attrs; ++j) {
                HV* attr = newHV();
                hv_store(attr, "name", 4, newSVpvn(list[i].attrs[j].name,
                 list[i].attrs[j].name_len), 0/*hash*/);
                hv_store(attr, "value", 5, newSVpvn(list[i].attrs[j].value,
                 list[i].attrs[j].value_len), 0/*hash*/);
                hv_store(attr, "mandatory", 9,
                 newSViv(list[i].attrs[j].mandatory), 0/*hash*/);
                av_store(av, j, newRV_noinc((SV*)attr));
            }

            ST(i) = sv_2mortal(newRV_noinc((SV*)hv));
        }
    }

    libssh2_publickey_list_free(pk->pkey, list);

    if (GIMME_V == G_ARRAY)
        XSRETURN(keys);
    XSRETURN_UV(keys);
#line 5034 "SSH2.c"
	PUTBACK;
	return;
    }
}

#undef class
#define class "Net::SSH2::KnownHosts"
#if LIBSSH2_VERSION_NUM >= 0x010200
#define XSubPPtmpAAAZ 1


XS_EUPXS(XS_Net__SSH2__KnownHosts_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "kh");
    {
	SSH2_KNOWNHOSTS *    kh = INT2PTR(SSH2_KNOWNHOSTS *, unwrap(ST(0), "Net::SSH2::KnownHosts", "net_kh_DESTROY"))
;
#line 2597 "SSH2.xs"
    debug("%s::DESTROY\n", class);
    libssh2_knownhost_free(kh->knownhosts);
    SvREFCNT_dec(kh->sv_ss);
    Safefree(kh);
#line 5060 "SSH2.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_readfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_readfile)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "kh, filename");
    {
	SSH2_BYTES	RETVAL;
	SSH2_KNOWNHOSTS *    kh = INT2PTR(SSH2_KNOWNHOSTS *, unwrap(ST(0), "Net::SSH2::KnownHosts", "net_kh_readfile"))
;
	SSH2_CHARP    filename = SvPVbyte_nolen(ST(1))
;
#line 2605 "SSH2.xs"
    RETVAL = libssh2_knownhost_readfile(kh->knownhosts, filename, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
#line 5080 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : newSVuv(RETVAL) );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_writefile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_writefile)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "kh, filename");
    {
	SSH2_NERROR	RETVAL;
	SSH2_KNOWNHOSTS *    kh = INT2PTR(SSH2_KNOWNHOSTS *, unwrap(ST(0), "Net::SSH2::KnownHosts", "net_kh_writefile"))
;
	SSH2_CHARP    filename = SvPVbyte_nolen(ST(1))
;
#line 2612 "SSH2.xs"
    RETVAL = libssh2_knownhost_writefile(kh->knownhosts, filename, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
    save_eagain(kh->ss->session, RETVAL);
#line 5107 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_add)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "kh, host, salt, key, comment, typemask");
    {
#line 2620 "SSH2.xs"
    STRLEN key_len, comment_len;
    const char *key_pv, *comment_pv;
#line 5129 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_KNOWNHOSTS *    kh = INT2PTR(SSH2_KNOWNHOSTS *, unwrap(ST(0), "Net::SSH2::KnownHosts", "net_kh_add"))
;
	SSH2_CHARP    host = SvPVbyte_nolen(ST(1))
;
	SSH2_CHARP    salt = SvPVbyte_nolen(ST(2))
;
	SV *	key = ST(3)
;
	SV *	comment = ST(4)
;
	int	typemask = (int)SvIV(ST(5))
;
#line 2623 "SSH2.xs"
    key_pv = SvPVbyte(key, key_len);
    if (SvOK(comment))
        comment_pv = SvPVbyte(comment, comment_len);
    else {
        comment_pv = NULL;
        comment_len = 0;
    }
#if LIBSSH2_VERSION_NUM >= 0x010205
    RETVAL = libssh2_knownhost_addc(kh->knownhosts, host, salt, key_pv, key_len,
                                    comment_pv, comment_len, typemask, NULL);
#else
    RETVAL = libssh2_knownhost_add(kh->knownhosts, host, salt, key_pv, key_len,
                                   typemask, NULL);
#endif
    save_eagain(kh->ss->session, RETVAL);
#line 5159 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_check); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_check)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "kh, host, port, key, typemask");
    {
#line 2644 "SSH2.xs"
    STRLEN key_len;
    const char *key_pv;
    UV port_uv;
#line 5182 "SSH2.c"
	int	RETVAL;
	dXSTARG;
	SSH2_KNOWNHOSTS *    kh = INT2PTR(SSH2_KNOWNHOSTS *, unwrap(ST(0), "Net::SSH2::KnownHosts", "net_kh_check"))
;
	SSH2_CHARP    host = SvPVbyte_nolen(ST(1))
;
	SV *	port = ST(2)
;
	SV *	key = ST(3)
;
	int	typemask = (int)SvIV(ST(4))
;
#line 2648 "SSH2.xs"
    key_pv = SvPVbyte(key, key_len);
    port_uv = (SvOK(port) ? SvUV(port) : 0);
#if LIBSSH2_VERSION_NUM >= 0x010206
    RETVAL = libssh2_knownhost_checkp(kh->knownhosts, host, port_uv,
                                      key_pv, key_len, typemask, NULL);
#else
    if ((port_uv != 0) && (port_uv != 22))
        croak("libssh2 version 1.2.6 is required when using a custom TCP port");
    RETVAL = libssh2_knownhost_check(kh->knownhosts, host,
                                     key_pv, key_len, typemask, NULL);
#endif
#line 5207 "SSH2.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_readline); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_readline)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "kh, line");
    {
#line 2665 "SSH2.xs"
    STRLEN line_len;
    const char *line_pv;
#line 5224 "SSH2.c"
	SSH2_NERROR	RETVAL;
	SSH2_KNOWNHOSTS *    kh = INT2PTR(SSH2_KNOWNHOSTS *, unwrap(ST(0), "Net::SSH2::KnownHosts", "net_kh_readline"))
;
	SV *	line = ST(1)
;
#line 2668 "SSH2.xs"
    line_pv = SvPVbyte(line, line_len);
    RETVAL = libssh2_knownhost_readline(kh->knownhosts, line_pv, line_len, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
    save_eagain(kh->ss->session, RETVAL);
#line 5234 "SSH2.c"
	{
	    SV * RETVALSV;
    RETVALSV = ( ((RETVAL) < 0) ? &PL_sv_undef : &PL_sv_yes );
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Net__SSH2__KnownHosts_writeline); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Net__SSH2__KnownHosts_writeline)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "kh, host, port, key, typemask");
    {
#line 2677 "SSH2.xs"
    int rc;
    STRLEN key_len;
    const char *key_pv;
    UV port_uv;
    size_t line_len;
    STRLEN buffer_len;
    SV *buffer;
    struct libssh2_knownhost *entry = NULL;
#line 5262 "SSH2.c"
	SV *	RETVAL;
	SSH2_KNOWNHOSTS *    kh = INT2PTR(SSH2_KNOWNHOSTS *, unwrap(ST(0), "Net::SSH2::KnownHosts", "net_kh_writeline"))
;
	SSH2_CHARP    host = SvPVbyte_nolen(ST(1))
;
	SV *	port = ST(2)
;
	SV *	key = ST(3)
;
	int	typemask = (int)SvIV(ST(4))
;
#line 2686 "SSH2.xs"
    RETVAL = &PL_sv_undef;
    key_pv = SvPVbyte(key, key_len);
    port_uv = (SvOK(port) ? SvUV(port) : 0);
#if LIBSSH2_VERSION_NUM >= 0x010206
    rc = libssh2_knownhost_checkp(kh->knownhosts, host, port_uv,
                                  key_pv, key_len, typemask, &entry);
#else
    if ((port_uv != 0) && (port_uv != 22))
        croak("libssh2 version 1.2.6 is required when using a custom TCP port");
    rc = libssh2_knownhost_check(kh->knownhosts, host,
                                 key_pv, key_len, typemask, &entry);
#endif
    if ((rc != LIBSSH2_KNOWNHOST_CHECK_MATCH) || !entry) {
#if LIBSSH2_VERSION_NUM >= 0x010601
        libssh2_session_set_last_error(kh->ss->session, LIBSSH2_ERROR_KNOWN_HOSTS, "matching host key not found");
#endif
    }
    else {
        buffer = sv_2mortal(newSV(512));
        SvPOK_on(buffer);
        while (1) {
            rc = libssh2_knownhost_writeline(kh->knownhosts, entry,
                                             SvPVX(buffer), SvLEN(buffer),
                                             &line_len, LIBSSH2_KNOWNHOST_FILE_OPENSSH);
            if (rc == LIBSSH2_ERROR_NONE) {
                SvPVX(buffer)[line_len] = '\0';
                SvCUR_set(buffer, line_len);
                RETVAL = SvREFCNT_inc(buffer);
                break;
            }

            if ((rc != LIBSSH2_ERROR_BUFFER_TOO_SMALL) ||
                (SvLEN(buffer) > 256 * 1024)) break;

            SvGROW(buffer, SvLEN(buffer) * 2);
        }
    }
#line 5312 "SSH2.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#endif
#undef class
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Net__SSH2); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Net__SSH2)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Net::SSH2::constant", XS_Net__SSH2_constant);
        newXS_deffile("Net::SSH2::CLONE", XS_Net__SSH2_CLONE);
        newXS_deffile("Net::SSH2::_parse_constant", XS_Net__SSH2__parse_constant);
        newXS_deffile("Net::SSH2::_new", XS_Net__SSH2__new);
        newXS_deffile("Net::SSH2::trace", XS_Net__SSH2_trace);
#if XSubPPtmpAAAA
        newXS_deffile("Net::SSH2::block_directions", XS_Net__SSH2_block_directions);
#endif
#if XSubPPtmpAAAB
        newXS_deffile("Net::SSH2::block_directions", XS_Net__SSH2_block_directions);
#endif
#if XSubPPtmpAAAC
        newXS_deffile("Net::SSH2::timeout", XS_Net__SSH2_timeout);
#endif
#if XSubPPtmpAAAD
        newXS_deffile("Net::SSH2::timeout", XS_Net__SSH2_timeout);
#endif
        newXS_deffile("Net::SSH2::blocking", XS_Net__SSH2_blocking);
        newXS_deffile("Net::SSH2::DESTROY", XS_Net__SSH2_DESTROY);
        newXS_deffile("Net::SSH2::debug", XS_Net__SSH2_debug);
        newXS_deffile("Net::SSH2::version", XS_Net__SSH2_version);
        newXS_deffile("Net::SSH2::banner", XS_Net__SSH2_banner);
        newXS_deffile("Net::SSH2::error", XS_Net__SSH2_error);
        newXS_deffile("Net::SSH2::_set_error", XS_Net__SSH2__set_error);
        newXS_deffile("Net::SSH2::_method", XS_Net__SSH2__method);
#if XSubPPtmpAAAE
        newXS_deffile("Net::SSH2::flag", XS_Net__SSH2_flag);
#endif
#if XSubPPtmpAAAF
        newXS_deffile("Net::SSH2::flag", XS_Net__SSH2_flag);
#endif
        newXS_deffile("Net::SSH2::callback", XS_Net__SSH2_callback);
        newXS_deffile("Net::SSH2::_startup", XS_Net__SSH2__startup);
        newXS_deffile("Net::SSH2::hostname", XS_Net__SSH2_hostname);
        newXS_deffile("Net::SSH2::port", XS_Net__SSH2_port);
        newXS_deffile("Net::SSH2::sock", XS_Net__SSH2_sock);
        newXS_deffile("Net::SSH2::disconnect", XS_Net__SSH2_disconnect);
        newXS_deffile("Net::SSH2::hostkey_hash", XS_Net__SSH2_hostkey_hash);
        newXS_deffile("Net::SSH2::remote_hostkey", XS_Net__SSH2_remote_hostkey);
        newXS_deffile("Net::SSH2::_auth_list", XS_Net__SSH2__auth_list);
        newXS_deffile("Net::SSH2::auth_ok", XS_Net__SSH2_auth_ok);
        newXS_deffile("Net::SSH2::auth_password", XS_Net__SSH2_auth_password);
#if XSubPPtmpAAAG
        newXS_deffile("Net::SSH2::auth_agent", XS_Net__SSH2_auth_agent);
#endif
#if XSubPPtmpAAAH
        newXS_deffile("Net::SSH2::auth_agent", XS_Net__SSH2_auth_agent);
#endif
        newXS_deffile("Net::SSH2::auth_publickey", XS_Net__SSH2_auth_publickey);
#if XSubPPtmpAAAI
        newXS_deffile("Net::SSH2::auth_publickey_frommemory", XS_Net__SSH2_auth_publickey_frommemory);
#endif
        newXS_deffile("Net::SSH2::auth_hostbased", XS_Net__SSH2_auth_hostbased);
        newXS_deffile("Net::SSH2::auth_keyboard", XS_Net__SSH2_auth_keyboard);
#if XSubPPtmpAAAJ
        newXS_deffile("Net::SSH2::keepalive_config", XS_Net__SSH2_keepalive_config);
        newXS_deffile("Net::SSH2::keepalive_send", XS_Net__SSH2_keepalive_send);
#endif
#if XSubPPtmpAAAK
        newXS_deffile("Net::SSH2::keepalive_config", XS_Net__SSH2_keepalive_config);
        newXS_deffile("Net::SSH2::keepalive_send", XS_Net__SSH2_keepalive_send);
#endif
        newXS_deffile("Net::SSH2::channel", XS_Net__SSH2_channel);
#if XSubPPtmpAAAL
        newXS_deffile("Net::SSH2::_scp_get", XS_Net__SSH2__scp_get);
#endif
#if XSubPPtmpAAAM
        newXS_deffile("Net::SSH2::_scp_get", XS_Net__SSH2__scp_get);
#endif
#if XSubPPtmpAAAN
        newXS_deffile("Net::SSH2::_scp_put", XS_Net__SSH2__scp_put);
#endif
#if XSubPPtmpAAAO
        newXS_deffile("Net::SSH2::_scp_put", XS_Net__SSH2__scp_put);
#endif
        newXS_deffile("Net::SSH2::tcpip", XS_Net__SSH2_tcpip);
        newXS_deffile("Net::SSH2::listen", XS_Net__SSH2_listen);
#if XSubPPtmpAAAP
        newXS_deffile("Net::SSH2::known_hosts", XS_Net__SSH2_known_hosts);
#endif
#if XSubPPtmpAAAQ
        newXS_deffile("Net::SSH2::known_hosts", XS_Net__SSH2_known_hosts);
#endif
        newXS_deffile("Net::SSH2::_poll", XS_Net__SSH2__poll);
        newXS_deffile("Net::SSH2::sftp", XS_Net__SSH2_sftp);
        newXS_deffile("Net::SSH2::public_key", XS_Net__SSH2_public_key);
        newXS_deffile("Net::SSH2::Channel::DESTROY", XS_Net__SSH2__Channel_DESTROY);
        newXS_deffile("Net::SSH2::Channel::session", XS_Net__SSH2__Channel_session);
        newXS_deffile("Net::SSH2::Channel::_setenv", XS_Net__SSH2__Channel__setenv);
#if XSubPPtmpAAAR
        newXS_deffile("Net::SSH2::Channel::_exit_signal", XS_Net__SSH2__Channel__exit_signal);
#endif
#if XSubPPtmpAAAS
        newXS_deffile("Net::SSH2::Channel::_exit_signal", XS_Net__SSH2__Channel__exit_signal);
#endif
        newXS_deffile("Net::SSH2::Channel::eof", XS_Net__SSH2__Channel_eof);
        newXS_deffile("Net::SSH2::Channel::send_eof", XS_Net__SSH2__Channel_send_eof);
        newXS_deffile("Net::SSH2::Channel::close", XS_Net__SSH2__Channel_close);
        newXS_deffile("Net::SSH2::Channel::_wait_closed", XS_Net__SSH2__Channel__wait_closed);
        newXS_deffile("Net::SSH2::Channel::wait_eof", XS_Net__SSH2__Channel_wait_eof);
        newXS_deffile("Net::SSH2::Channel::_exit_status", XS_Net__SSH2__Channel__exit_status);
#if XSubPPtmpAAAT
        newXS_deffile("Net::SSH2::Channel::_pty", XS_Net__SSH2__Channel__pty);
        newXS_deffile("Net::SSH2::Channel::pty_size", XS_Net__SSH2__Channel_pty_size);
#endif
#if XSubPPtmpAAAU
        newXS_deffile("Net::SSH2::Channel::pty", XS_Net__SSH2__Channel_pty);
        newXS_deffile("Net::SSH2::Channel::pty_size", XS_Net__SSH2__Channel_pty_size);
#endif
        newXS_deffile("Net::SSH2::Channel::process", XS_Net__SSH2__Channel_process);
        newXS_deffile("Net::SSH2::Channel::ext_data", XS_Net__SSH2__Channel_ext_data);
        newXS_deffile("Net::SSH2::Channel::read", XS_Net__SSH2__Channel_read);
        newXS_deffile("Net::SSH2::Channel::getc", XS_Net__SSH2__Channel_getc);
        newXS_deffile("Net::SSH2::Channel::write", XS_Net__SSH2__Channel_write);
#if XSubPPtmpAAAV
        newXS_deffile("Net::SSH2::Channel::receive_window_adjust", XS_Net__SSH2__Channel_receive_window_adjust);
#endif
#if XSubPPtmpAAAW
        newXS_deffile("Net::SSH2::Channel::receive_window_adjust", XS_Net__SSH2__Channel_receive_window_adjust);
#endif
#if XSubPPtmpAAAX
        newXS_deffile("Net::SSH2::Channel::window_write", XS_Net__SSH2__Channel_window_write);
        newXS_deffile("Net::SSH2::Channel::window_read", XS_Net__SSH2__Channel_window_read);
#endif
#if XSubPPtmpAAAY
        newXS_deffile("Net::SSH2::Channel::window_write", XS_Net__SSH2__Channel_window_write);
        newXS_deffile("Net::SSH2::Channel::window_read", XS_Net__SSH2__Channel_window_read);
#endif
        newXS_deffile("Net::SSH2::Channel::flush", XS_Net__SSH2__Channel_flush);
        newXS_deffile("Net::SSH2::Listener::DESTROY", XS_Net__SSH2__Listener_DESTROY);
        newXS_deffile("Net::SSH2::Listener::accept", XS_Net__SSH2__Listener_accept);
        newXS_deffile("Net::SSH2::SFTP::DESTROY", XS_Net__SSH2__SFTP_DESTROY);
        newXS_deffile("Net::SSH2::SFTP::session", XS_Net__SSH2__SFTP_session);
        newXS_deffile("Net::SSH2::SFTP::error", XS_Net__SSH2__SFTP_error);
        newXS_deffile("Net::SSH2::SFTP::open", XS_Net__SSH2__SFTP_open);
        newXS_deffile("Net::SSH2::SFTP::opendir", XS_Net__SSH2__SFTP_opendir);
        newXS_deffile("Net::SSH2::SFTP::unlink", XS_Net__SSH2__SFTP_unlink);
        newXS_deffile("Net::SSH2::SFTP::rename", XS_Net__SSH2__SFTP_rename);
        newXS_deffile("Net::SSH2::SFTP::mkdir", XS_Net__SSH2__SFTP_mkdir);
        newXS_deffile("Net::SSH2::SFTP::rmdir", XS_Net__SSH2__SFTP_rmdir);
        newXS_deffile("Net::SSH2::SFTP::stat", XS_Net__SSH2__SFTP_stat);
        newXS_deffile("Net::SSH2::SFTP::setstat", XS_Net__SSH2__SFTP_setstat);
        newXS_deffile("Net::SSH2::SFTP::symlink", XS_Net__SSH2__SFTP_symlink);
        newXS_deffile("Net::SSH2::SFTP::readlink", XS_Net__SSH2__SFTP_readlink);
        newXS_deffile("Net::SSH2::SFTP::realpath", XS_Net__SSH2__SFTP_realpath);
        newXS_deffile("Net::SSH2::File::DESTROY", XS_Net__SSH2__File_DESTROY);
        newXS_deffile("Net::SSH2::File::read", XS_Net__SSH2__File_read);
        newXS_deffile("Net::SSH2::File::getc", XS_Net__SSH2__File_getc);
        newXS_deffile("Net::SSH2::File::write", XS_Net__SSH2__File_write);
        newXS_deffile("Net::SSH2::File::stat", XS_Net__SSH2__File_stat);
        newXS_deffile("Net::SSH2::File::setstat", XS_Net__SSH2__File_setstat);
        newXS_deffile("Net::SSH2::File::seek", XS_Net__SSH2__File_seek);
        newXS_deffile("Net::SSH2::File::tell", XS_Net__SSH2__File_tell);
        newXS_deffile("Net::SSH2::Dir::DESTROY", XS_Net__SSH2__Dir_DESTROY);
        newXS_deffile("Net::SSH2::Dir::read", XS_Net__SSH2__Dir_read);
        newXS_deffile("Net::SSH2::PublicKey::DESTROY", XS_Net__SSH2__PublicKey_DESTROY);
        newXS_deffile("Net::SSH2::PublicKey::add", XS_Net__SSH2__PublicKey_add);
        newXS_deffile("Net::SSH2::PublicKey::remove", XS_Net__SSH2__PublicKey_remove);
        newXS_deffile("Net::SSH2::PublicKey::fetch", XS_Net__SSH2__PublicKey_fetch);
#if XSubPPtmpAAAZ
        newXS_deffile("Net::SSH2::KnownHosts::DESTROY", XS_Net__SSH2__KnownHosts_DESTROY);
        newXS_deffile("Net::SSH2::KnownHosts::readfile", XS_Net__SSH2__KnownHosts_readfile);
        newXS_deffile("Net::SSH2::KnownHosts::writefile", XS_Net__SSH2__KnownHosts_writefile);
        newXS_deffile("Net::SSH2::KnownHosts::add", XS_Net__SSH2__KnownHosts_add);
        newXS_deffile("Net::SSH2::KnownHosts::check", XS_Net__SSH2__KnownHosts_check);
        newXS_deffile("Net::SSH2::KnownHosts::readline", XS_Net__SSH2__KnownHosts_readline);
        newXS_deffile("Net::SSH2::KnownHosts::writeline", XS_Net__SSH2__KnownHosts_writeline);
#endif

    /* Initialisation Section */

#line 859 "SSH2.xs"
{
    MY_CXT_INIT;
#ifdef HAVE_GCRYPT
    gcry_error_t ret;
#ifndef WIN32
    ret = gcry_control(GCRYCTL_SET_THREAD_CBS, &gcry_threads_pthread);
#else
    ret = gcry_control(GCRYCTL_SET_THREAD_CBS, &gcry_threads_pth);
#endif
    if (gcry_err_code(ret) != GPG_ERR_NO_ERROR)
        croak("could not initialize libgcrypt for threads (%d: %s/%s)",
         gcry_err_code(ret),
         gcry_strsource(ret),
         gcry_strerror(ret));

    if (!gcry_check_version(GCRYPT_VERSION))
        croak("libgcrypt version mismatch (needed: %s)", GCRYPT_VERSION);
#else /* OpenSSL */
    openssl_threads_init();
    MY_CXT.global_cb_data = newHV();
    MY_CXT.tid = get_my_thread_id();
    debug("Net::SSH2::BOOT: tid=%d my_perl=0x%p\n", MY_CXT.tid, my_perl);
#endif
}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#if XSubPPtmpAAAH
#endif
#if XSubPPtmpAAAI
#endif
#if XSubPPtmpAAAJ
#endif
#if XSubPPtmpAAAK
#endif
#if XSubPPtmpAAAL
#endif
#if XSubPPtmpAAAM
#endif
#if XSubPPtmpAAAN
#endif
#if XSubPPtmpAAAO
#endif
#if XSubPPtmpAAAP
#endif
#if XSubPPtmpAAAQ
#endif
#if XSubPPtmpAAAR
#endif
#if XSubPPtmpAAAS
#endif
#if XSubPPtmpAAAT
#endif
#if XSubPPtmpAAAU
#endif
#if XSubPPtmpAAAV
#endif
#if XSubPPtmpAAAW
#endif
#if XSubPPtmpAAAX
#endif
#if XSubPPtmpAAAY
#endif
#if XSubPPtmpAAAZ
#endif
#line 5598 "SSH2.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

